local __exports = LibStub:NewLibrary("ovale/scripts/ovale_shaman", 90107)
if not __exports then return end
__exports.registerShaman = function(scripts)
    do
        local name = "sc_t27_shaman_elemental"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Elemental"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Elemental".
#	class=shaman
#	spec=elemental
#	talents=2301032

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(elemental)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(elemental)))

AddFunction elementalinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction elementaluseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

### actions.single_target

AddFunction elementalsingle_targetmainactions
{
 #lightning_bolt,if=(buff.stormkeeper.remains<1.1*gcd*buff.stormkeeper.stack)
 if buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) spell(lightning_bolt)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
 #flame_shock,target_if=(!ticking|dot.flame_shock.remains<=gcd|talent.ascendance.enabled&dot.flame_shock.remains<(cooldown.ascendance.remains+buff.ascendance.duration)&cooldown.ascendance.remains<4)&(buff.lava_surge.up|!buff.bloodlust.up)
 if { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } spell(flame_shock)
 #flame_shock,if=buff.primordial_wave.up,target_if=min:dot.flame_shock.remains,cycle_targets=1,target_if=refreshable
 if buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) spell(flame_shock)
 #lava_burst,if=buff.lava_surge.up&(runeforge.windspeakers_lava_resurgence.equipped|!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&(maelstrom<70)
 if hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 spell(elemental_blast)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) spell(lava_burst)
 #earthquake,if=buff.echoes_of_great_sundering.up&talent.master_of_the_elements.enabled&buff.master_of_the_elements.up
 if buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up&buff.master_of_the_elements.up&maelstrom<60
 if buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up&(talent.master_of_the_elements.enabled&(buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earthquake)
 #earthquake,if=spell_targets.chain_lightning>1&!dot.flame_shock.refreshable&!runeforge.echoes_of_great_sundering.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } spell(earthquake)
 #lava_burst,if=cooldown_react&(!buff.master_of_the_elements.up&buff.icefury.up)
 if not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled&!buff.icefury.up
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=talent.echo_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50&!buff.echoes_of_great_sundering.up
 if hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) spell(lava_burst)
 #earth_shock,if=(runeforge.echoes_of_great_sundering.equipped|spell_targets.chain_lightning<2)&(talent.master_of_the_elements.enabled&!buff.echoes_of_great_sundering.up&(buff.master_of_the_elements.up|maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earth_shock)
 #frost_shock,if=talent.icefury.enabled&talent.master_of_the_elements.enabled&buff.icefury.up&buff.master_of_the_elements.up
 if hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) spell(frost_shock)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react&!talent.master_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&(buff.icefury.remains<gcd*4*buff.icefury.stack|buff.stormkeeper.up|!talent.master_of_the_elements.enabled)
 if hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } spell(frost_shock)
 #lava_burst
 spell(lava_burst)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,if=runeforge.elemental_equilibrium.equipped&!buff.elemental_equilibrium_debuff.up&!talent.elemental_blast.enabled&!talent.echoing_shock.enabled
 if equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=spell_targets.chain_lightning>1
 if enemies(tagged=1) > 1 spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
}

AddFunction elementalsingle_targetmainpostconditions
{
}

AddFunction elementalsingle_targetshortcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)&(maelstrom<44)
  if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() spell(echoing_shock)

  unless hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst)
  {
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)

   unless buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst)
   {
    #icefury,if=talent.icefury.enabled&!(maelstrom>35&cooldown.lava_burst.remains<=0)
    if hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } spell(icefury)

    unless hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock)
    {
     #chain_harvest
     spell(chain_harvest)

     unless hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
     {
      #static_discharge,if=talent.static_discharge.enabled
      if hastalent(static_discharge_talent) spell(static_discharge)
     }
    }
   }
  }
 }
}

AddFunction elementalsingle_targetshortcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

AddFunction elementalsingle_targetcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(time>=60|buff.bloodlust.up)&(cooldown.lava_burst.remains>0)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and { timeincombat() >= 60 or buffpresent(bloodlust) } and spellcooldown(lava_burst) > 0 and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)

  unless buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless hastalent(static_discharge_talent) and spell(static_discharge)
   {
    #earth_elemental,if=!talent.primal_elementalist.enabled|!pet.fire_elemental.active
    if not hastalent(primal_elementalist_talent) or not pet.present() spell(earth_elemental)
   }
  }
 }
}

AddFunction elementalsingle_targetcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

### actions.se_single_target

AddFunction elementalse_single_targetmainactions
{
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack&buff.wind_gust.stack<18
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 spell(frost_shock)
 #elemental_blast,if=talent.elemental_blast.enabled
 if hastalent(elemental_blast_talent_elemental) spell(elemental_blast)
 #lava_burst,if=(buff.wind_gust.stack<18&!buff.bloodlust.up)|buff.lava_surge.up
 if buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) spell(lava_burst)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning<2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 spell(lava_burst)
 #earthquake,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning>=2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up
 if buffpresent(stormkeeper) spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up
 if buffpresent(echoes_of_great_sundering_buff) spell(earthquake)
 #earth_shock,if=spell_targets.chain_lightning<2&maelstrom>=60&(buff.wind_gust.stack<20|maelstrom>90)|(runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up)
 if enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #earthquake,if=(spell_targets.chain_lightning>1)&(!dot.flame_shock.refreshable)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) spell(earthquake)
 #chain_lightning,if=active_enemies>1&pet.storm_elemental.active&buff.bloodlust.up
 if enemies() > 1 and pet.present() and buffpresent(bloodlust) spell(chain_lightning)
 #lightning_bolt,if=pet.storm_elemental.active&buff.bloodlust.up
 if pet.present() and buffpresent(bloodlust) spell(lightning_bolt)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react
 if not spellcooldown(lava_burst) > 0 spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=active_enemies>1&(spell_targets.chain_lightning>1|spell_targets.lava_beam>1)
 if enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalse_single_targetmainpostconditions
{
}

AddFunction elementalse_single_targetshortcdactions
{
 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd&spell_targets.chain_lightning<2|maelstrom>=60&spell_targets.chain_lightning>=2&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)|spell_targets.chain_lightning<2&buff.wind_gust.stack>=18&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&maelstrom>=60
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 spell(echoing_shock)

  unless { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #chain_harvest
   spell(chain_harvest)
   #static_discharge,if=talent.static_discharge.enabled
   if hastalent(static_discharge_talent) spell(static_discharge)
  }
 }
}

AddFunction elementalse_single_targetshortcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalse_single_targetcdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest)
 {
  #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
  if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

  unless hastalent(static_discharge_talent) and spell(static_discharge)
  {
   #earth_elemental,if=!talent.primal_elementalist.enabled|talent.primal_elementalist.enabled&(!pet.storm_elemental.active)
   if not hastalent(primal_elementalist_talent) or hastalent(primal_elementalist_talent) and not pet.present() spell(earth_elemental)
  }
 }
}

AddFunction elementalse_single_targetcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.precombat

AddFunction elementalprecombatmainactions
{
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<3
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 spell(elemental_blast)
 #lava_burst,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning<3|buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) spell(lava_burst)
 #chain_lightning,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning>=3&!buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) spell(chain_lightning)
}

AddFunction elementalprecombatmainpostconditions
{
}

AddFunction elementalprecombatshortcdactions
{
 #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)
 if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } spell(stormkeeper)
}

AddFunction elementalprecombatshortcdpostconditions
{
 hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

AddFunction elementalprecombatcdactions
{
 #flask
 #food
 #augmentation
 #earth_elemental,if=!talent.primal_elementalist.enabled
 if not hastalent(primal_elementalist_talent) spell(earth_elemental)

 unless hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper)
 {
  #fire_elemental
  spell(fire_elemental)

  unless hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
  {
   #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
   if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
   #snapshot_stats
   #potion
   if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
  }
 }
}

AddFunction elementalprecombatcdpostconditions
{
 hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

### actions.aoe

AddFunction elementalaoemainactions
{
 #earthquake,if=buff.echoing_shock.up
 if buffpresent(echoing_shock) spell(earthquake)
 #flame_shock,if=(active_dot.flame_shock<2&active_enemies<=3&cooldown.primordial_wave.remains<16&covenant.necrolord&!pet.storm_elemental.active|active_dot.flame_shock<1&active_enemies>=4&!pet.storm_elemental.active&talent.master_of_the_elements.enabled)|(runeforge.skybreakers_fiery_demise.equipped&!pet.storm_elemental.active),target_if=refreshable
 if { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,if=!active_dot.flame_shock&!pet.storm_elemental.active&(talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #chain_lightning,if=spell_targets.chain_lightning<4&buff.master_of_the_elements.up&maelstrom<50
 if enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 spell(chain_lightning)
 #earth_shock,if=runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up
 if equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&(buff.lava_surge.up&!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2&!runeforge.echoes_of_great_sundering.equipped&(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up)
 if enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lava_burst,target_if=dot.flame_shock.remains,if=buff.lava_surge.up&buff.primordial_wave.up
 if target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=(spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&talent.master_of_the_elements.enabled)|(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&!runeforge.skybreakers_fiery_demise.equipped)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning=4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2
 if enemies(tagged=1) >= 2 spell(earthquake)
 #chain_lightning,if=buff.stormkeeper.remains<3*gcd*buff.stormkeeper.stack
 if buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) spell(chain_lightning)
 #lava_burst,if=buff.lava_surge.up&spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&dot.flame_shock.ticking
 if buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<5&(!pet.storm_elemental.active)
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() spell(elemental_blast)
 #lava_beam,if=talent.ascendance.enabled
 if hastalent(ascendance_talent) spell(lava_beam)
 #chain_lightning
 spell(chain_lightning)
 #lava_burst,moving=1,if=buff.lava_surge.up&cooldown_react
 if speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } spell(lava_burst)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalaoemainpostconditions
{
}

AddFunction elementalaoeshortcdactions
{
 unless buffpresent(echoing_shock) and spell(earthquake)
 {
  #chain_harvest
  spell(chain_harvest)
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)

  unless { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #echoing_shock,if=talent.echoing_shock.enabled&maelstrom>=60&(runeforge.echoes_of_great_sundering.equipped&buff.echoes_of_great_sundering.up|!runeforge.echoes_of_great_sundering.equipped)
   if hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } spell(echoing_shock)
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)
  }
 }
}

AddFunction elementalaoeshortcdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalaoecdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(!pet.storm_elemental.active)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and not pet.present() and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)
 }
}

AddFunction elementalaoecdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.default

AddFunction elemental_defaultmainactions
{
 #flame_shock,if=(!talent.elemental_blast.enabled)&!ticking&!pet.storm_elemental.active&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #flame_shock,if=!ticking&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20)&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
 if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoemainactions()

 unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions()
 {
  #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
  if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetmainactions()

  unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions()
  {
   #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
   if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetmainactions()
  }
 }
}

AddFunction elemental_defaultmainpostconditions
{
 enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetmainpostconditions()
}

AddFunction elemental_defaultshortcdactions
{
 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20|soulbind.lead_by_example.enabled)&(spell_targets.chain_lightning<5|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped|soulbind.lead_by_example.enabled)
  if not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } spell(primordial_wave)

  unless not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
   if not hastalent(ascendance_talent) or not buffpresent(ascendance) spell(bag_of_tricks)
   #vesper_totem,if=covenant.kyrian
   if iscovenant("kyrian") spell(vesper_totem)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoeshortcdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetshortcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetshortcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultshortcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetshortcdpostconditions()
}

AddFunction elemental_defaultcdactions
{
 #spiritwalkers_grace,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(spiritwalkers_grace)
 #wind_shear
 elementalinterruptactions()
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
 #use_items
 elementaluseitemactions()

 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #fire_elemental
  spell(fire_elemental)
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent) or buffpresent(ascendance) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem)
  {
   #fae_transfusion,if=covenant.night_fae&!runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up)&spell_targets.chain_lightning<3
   if iscovenant("night_fae") and not equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) } and enemies(tagged=1) < 3 spell(fae_transfusion)
   #fae_transfusion,if=covenant.night_fae&runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|spell_targets.chain_lightning>=3)&(cooldown.fire_elemental.remains>20|cooldown.storm_elemental.remains>20)
   if iscovenant("night_fae") and equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or enemies(tagged=1) >= 3 } and { spellcooldown(fire_elemental) > 20 or spellcooldown(storm_elemental) > 20 } spell(fae_transfusion)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoecdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetcdpostconditions()
}

### Elemental icons.

AddCheckBox(opt_shaman_elemental_aoe l(aoe) default enabled=(specialization(elemental)))

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(specialization(elemental)) enemies=1 help=main
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=aoe
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance
# ascendance_talent
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# earth_elemental
# earth_shock
# earthquake
# echo_of_the_elements_talent_elemental
# echoes_of_great_sundering_buff
# echoes_of_great_sundering_runeforge
# echoing_shock
# echoing_shock_talent
# elemental_blast
# elemental_blast_talent_elemental
# elemental_equilibrium_buff
# elemental_equilibrium_runeforge
# fae_transfusion
# fire_elemental
# fireblood
# flame_shock
# fleshcraft
# frost_shock
# hex
# icefury
# icefury_talent
# lava_beam
# lava_burst
# lava_surge_buff
# lead_by_example_soulbind
# lightning_bolt
# liquid_magma_totem
# liquid_magma_totem_talent
# master_of_the_elements_buff
# master_of_the_elements_talent
# potion_of_spectral_intellect_item
# primal_elementalist_talent
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# skybreakers_fiery_demise_runeforge
# spiritwalkers_grace
# static_discharge
# static_discharge_talent
# storm_elemental
# storm_elemental_talent
# stormkeeper
# stormkeeper_talent
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_gust_buff
# wind_shear
# windspeakers_lava_resurgence_runeforge
]]
        scripts:registerScript("SHAMAN", "elemental", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_elemental_kyrian"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Elemental_Kyrian"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Elemental_Kyrian".
#	class=shaman
#	spec=elemental
#	talents=2301032

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(elemental)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(elemental)))

AddFunction elementalinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction elementaluseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

### actions.single_target

AddFunction elementalsingle_targetmainactions
{
 #lightning_bolt,if=(buff.stormkeeper.remains<1.1*gcd*buff.stormkeeper.stack)
 if buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) spell(lightning_bolt)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
 #flame_shock,target_if=(!ticking|dot.flame_shock.remains<=gcd|talent.ascendance.enabled&dot.flame_shock.remains<(cooldown.ascendance.remains+buff.ascendance.duration)&cooldown.ascendance.remains<4)&(buff.lava_surge.up|!buff.bloodlust.up)
 if { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } spell(flame_shock)
 #flame_shock,if=buff.primordial_wave.up,target_if=min:dot.flame_shock.remains,cycle_targets=1,target_if=refreshable
 if buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) spell(flame_shock)
 #lava_burst,if=buff.lava_surge.up&(runeforge.windspeakers_lava_resurgence.equipped|!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&(maelstrom<70)
 if hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 spell(elemental_blast)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) spell(lava_burst)
 #earthquake,if=buff.echoes_of_great_sundering.up&talent.master_of_the_elements.enabled&buff.master_of_the_elements.up
 if buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up&buff.master_of_the_elements.up&maelstrom<60
 if buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up&(talent.master_of_the_elements.enabled&(buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earthquake)
 #earthquake,if=spell_targets.chain_lightning>1&!dot.flame_shock.refreshable&!runeforge.echoes_of_great_sundering.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } spell(earthquake)
 #lava_burst,if=cooldown_react&(!buff.master_of_the_elements.up&buff.icefury.up)
 if not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled&!buff.icefury.up
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=talent.echo_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50&!buff.echoes_of_great_sundering.up
 if hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) spell(lava_burst)
 #earth_shock,if=(runeforge.echoes_of_great_sundering.equipped|spell_targets.chain_lightning<2)&(talent.master_of_the_elements.enabled&!buff.echoes_of_great_sundering.up&(buff.master_of_the_elements.up|maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earth_shock)
 #frost_shock,if=talent.icefury.enabled&talent.master_of_the_elements.enabled&buff.icefury.up&buff.master_of_the_elements.up
 if hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) spell(frost_shock)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react&!talent.master_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&(buff.icefury.remains<gcd*4*buff.icefury.stack|buff.stormkeeper.up|!talent.master_of_the_elements.enabled)
 if hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } spell(frost_shock)
 #lava_burst
 spell(lava_burst)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,if=runeforge.elemental_equilibrium.equipped&!buff.elemental_equilibrium_debuff.up&!talent.elemental_blast.enabled&!talent.echoing_shock.enabled
 if equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=spell_targets.chain_lightning>1
 if enemies(tagged=1) > 1 spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
}

AddFunction elementalsingle_targetmainpostconditions
{
}

AddFunction elementalsingle_targetshortcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)&(maelstrom<44)
  if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() spell(echoing_shock)

  unless hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst)
  {
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)

   unless buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst)
   {
    #icefury,if=talent.icefury.enabled&!(maelstrom>35&cooldown.lava_burst.remains<=0)
    if hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } spell(icefury)

    unless hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock)
    {
     #chain_harvest
     spell(chain_harvest)

     unless hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
     {
      #static_discharge,if=talent.static_discharge.enabled
      if hastalent(static_discharge_talent) spell(static_discharge)
     }
    }
   }
  }
 }
}

AddFunction elementalsingle_targetshortcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

AddFunction elementalsingle_targetcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(time>=60|buff.bloodlust.up)&(cooldown.lava_burst.remains>0)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and { timeincombat() >= 60 or buffpresent(bloodlust) } and spellcooldown(lava_burst) > 0 and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)

  unless buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless hastalent(static_discharge_talent) and spell(static_discharge)
   {
    #earth_elemental,if=!talent.primal_elementalist.enabled|!pet.fire_elemental.active
    if not hastalent(primal_elementalist_talent) or not pet.present() spell(earth_elemental)
   }
  }
 }
}

AddFunction elementalsingle_targetcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

### actions.se_single_target

AddFunction elementalse_single_targetmainactions
{
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack&buff.wind_gust.stack<18
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 spell(frost_shock)
 #elemental_blast,if=talent.elemental_blast.enabled
 if hastalent(elemental_blast_talent_elemental) spell(elemental_blast)
 #lava_burst,if=(buff.wind_gust.stack<18&!buff.bloodlust.up)|buff.lava_surge.up
 if buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) spell(lava_burst)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning<2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 spell(lava_burst)
 #earthquake,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning>=2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up
 if buffpresent(stormkeeper) spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up
 if buffpresent(echoes_of_great_sundering_buff) spell(earthquake)
 #earth_shock,if=spell_targets.chain_lightning<2&maelstrom>=60&(buff.wind_gust.stack<20|maelstrom>90)|(runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up)
 if enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #earthquake,if=(spell_targets.chain_lightning>1)&(!dot.flame_shock.refreshable)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) spell(earthquake)
 #chain_lightning,if=active_enemies>1&pet.storm_elemental.active&buff.bloodlust.up
 if enemies() > 1 and pet.present() and buffpresent(bloodlust) spell(chain_lightning)
 #lightning_bolt,if=pet.storm_elemental.active&buff.bloodlust.up
 if pet.present() and buffpresent(bloodlust) spell(lightning_bolt)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react
 if not spellcooldown(lava_burst) > 0 spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=active_enemies>1&(spell_targets.chain_lightning>1|spell_targets.lava_beam>1)
 if enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalse_single_targetmainpostconditions
{
}

AddFunction elementalse_single_targetshortcdactions
{
 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd&spell_targets.chain_lightning<2|maelstrom>=60&spell_targets.chain_lightning>=2&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)|spell_targets.chain_lightning<2&buff.wind_gust.stack>=18&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&maelstrom>=60
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 spell(echoing_shock)

  unless { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #chain_harvest
   spell(chain_harvest)
   #static_discharge,if=talent.static_discharge.enabled
   if hastalent(static_discharge_talent) spell(static_discharge)
  }
 }
}

AddFunction elementalse_single_targetshortcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalse_single_targetcdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest)
 {
  #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
  if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

  unless hastalent(static_discharge_talent) and spell(static_discharge)
  {
   #earth_elemental,if=!talent.primal_elementalist.enabled|talent.primal_elementalist.enabled&(!pet.storm_elemental.active)
   if not hastalent(primal_elementalist_talent) or hastalent(primal_elementalist_talent) and not pet.present() spell(earth_elemental)
  }
 }
}

AddFunction elementalse_single_targetcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.precombat

AddFunction elementalprecombatmainactions
{
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<3
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 spell(elemental_blast)
 #lava_burst,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning<3|buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) spell(lava_burst)
 #chain_lightning,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning>=3&!buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) spell(chain_lightning)
}

AddFunction elementalprecombatmainpostconditions
{
}

AddFunction elementalprecombatshortcdactions
{
 #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)
 if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } spell(stormkeeper)
}

AddFunction elementalprecombatshortcdpostconditions
{
 hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

AddFunction elementalprecombatcdactions
{
 #flask
 #food
 #augmentation
 #earth_elemental,if=!talent.primal_elementalist.enabled
 if not hastalent(primal_elementalist_talent) spell(earth_elemental)

 unless hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper)
 {
  #fire_elemental
  spell(fire_elemental)

  unless hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
  {
   #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
   if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
   #snapshot_stats
   #potion
   if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
  }
 }
}

AddFunction elementalprecombatcdpostconditions
{
 hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

### actions.aoe

AddFunction elementalaoemainactions
{
 #earthquake,if=buff.echoing_shock.up
 if buffpresent(echoing_shock) spell(earthquake)
 #flame_shock,if=(active_dot.flame_shock<2&active_enemies<=3&cooldown.primordial_wave.remains<16&covenant.necrolord&!pet.storm_elemental.active|active_dot.flame_shock<1&active_enemies>=4&!pet.storm_elemental.active&talent.master_of_the_elements.enabled)|(runeforge.skybreakers_fiery_demise.equipped&!pet.storm_elemental.active),target_if=refreshable
 if { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,if=!active_dot.flame_shock&!pet.storm_elemental.active&(talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #chain_lightning,if=spell_targets.chain_lightning<4&buff.master_of_the_elements.up&maelstrom<50
 if enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 spell(chain_lightning)
 #earth_shock,if=runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up
 if equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&(buff.lava_surge.up&!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2&!runeforge.echoes_of_great_sundering.equipped&(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up)
 if enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lava_burst,target_if=dot.flame_shock.remains,if=buff.lava_surge.up&buff.primordial_wave.up
 if target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=(spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&talent.master_of_the_elements.enabled)|(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&!runeforge.skybreakers_fiery_demise.equipped)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning=4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2
 if enemies(tagged=1) >= 2 spell(earthquake)
 #chain_lightning,if=buff.stormkeeper.remains<3*gcd*buff.stormkeeper.stack
 if buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) spell(chain_lightning)
 #lava_burst,if=buff.lava_surge.up&spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&dot.flame_shock.ticking
 if buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<5&(!pet.storm_elemental.active)
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() spell(elemental_blast)
 #lava_beam,if=talent.ascendance.enabled
 if hastalent(ascendance_talent) spell(lava_beam)
 #chain_lightning
 spell(chain_lightning)
 #lava_burst,moving=1,if=buff.lava_surge.up&cooldown_react
 if speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } spell(lava_burst)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalaoemainpostconditions
{
}

AddFunction elementalaoeshortcdactions
{
 unless buffpresent(echoing_shock) and spell(earthquake)
 {
  #chain_harvest
  spell(chain_harvest)
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)

  unless { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #echoing_shock,if=talent.echoing_shock.enabled&maelstrom>=60&(runeforge.echoes_of_great_sundering.equipped&buff.echoes_of_great_sundering.up|!runeforge.echoes_of_great_sundering.equipped)
   if hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } spell(echoing_shock)
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)
  }
 }
}

AddFunction elementalaoeshortcdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalaoecdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(!pet.storm_elemental.active)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and not pet.present() and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)
 }
}

AddFunction elementalaoecdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.default

AddFunction elemental_defaultmainactions
{
 #flame_shock,if=(!talent.elemental_blast.enabled)&!ticking&!pet.storm_elemental.active&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #flame_shock,if=!ticking&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20)&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
 if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoemainactions()

 unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions()
 {
  #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
  if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetmainactions()

  unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions()
  {
   #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
   if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetmainactions()
  }
 }
}

AddFunction elemental_defaultmainpostconditions
{
 enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetmainpostconditions()
}

AddFunction elemental_defaultshortcdactions
{
 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20|soulbind.lead_by_example.enabled)&(spell_targets.chain_lightning<5|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped|soulbind.lead_by_example.enabled)
  if not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } spell(primordial_wave)

  unless not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
   if not hastalent(ascendance_talent) or not buffpresent(ascendance) spell(bag_of_tricks)
   #vesper_totem,if=covenant.kyrian
   if iscovenant("kyrian") spell(vesper_totem)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoeshortcdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetshortcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetshortcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultshortcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetshortcdpostconditions()
}

AddFunction elemental_defaultcdactions
{
 #spiritwalkers_grace,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(spiritwalkers_grace)
 #wind_shear
 elementalinterruptactions()
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
 #use_items
 elementaluseitemactions()

 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #fire_elemental
  spell(fire_elemental)
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent) or buffpresent(ascendance) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem)
  {
   #fae_transfusion,if=covenant.night_fae&!runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up)&spell_targets.chain_lightning<3
   if iscovenant("night_fae") and not equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) } and enemies(tagged=1) < 3 spell(fae_transfusion)
   #fae_transfusion,if=covenant.night_fae&runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|spell_targets.chain_lightning>=3)&(cooldown.fire_elemental.remains>20|cooldown.storm_elemental.remains>20)
   if iscovenant("night_fae") and equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or enemies(tagged=1) >= 3 } and { spellcooldown(fire_elemental) > 20 or spellcooldown(storm_elemental) > 20 } spell(fae_transfusion)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoecdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetcdpostconditions()
}

### Elemental icons.

AddCheckBox(opt_shaman_elemental_aoe l(aoe) default enabled=(specialization(elemental)))

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(specialization(elemental)) enemies=1 help=main
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=aoe
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance
# ascendance_talent
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# earth_elemental
# earth_shock
# earthquake
# echo_of_the_elements_talent_elemental
# echoes_of_great_sundering_buff
# echoes_of_great_sundering_runeforge
# echoing_shock
# echoing_shock_talent
# elemental_blast
# elemental_blast_talent_elemental
# elemental_equilibrium_buff
# elemental_equilibrium_runeforge
# fae_transfusion
# fire_elemental
# fireblood
# flame_shock
# fleshcraft
# frost_shock
# hex
# icefury
# icefury_talent
# lava_beam
# lava_burst
# lava_surge_buff
# lead_by_example_soulbind
# lightning_bolt
# liquid_magma_totem
# liquid_magma_totem_talent
# master_of_the_elements_buff
# master_of_the_elements_talent
# potion_of_spectral_intellect_item
# primal_elementalist_talent
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# skybreakers_fiery_demise_runeforge
# spiritwalkers_grace
# static_discharge
# static_discharge_talent
# storm_elemental
# storm_elemental_talent
# stormkeeper
# stormkeeper_talent
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_gust_buff
# wind_shear
# windspeakers_lava_resurgence_runeforge
]]
        scripts:registerScript("SHAMAN", "elemental", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_elemental_necrolord"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Elemental_Necrolord"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Elemental_Necrolord".
#	class=shaman
#	spec=elemental
#	talents=2301032

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(elemental)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(elemental)))

AddFunction elementalinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction elementaluseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

### actions.single_target

AddFunction elementalsingle_targetmainactions
{
 #lightning_bolt,if=(buff.stormkeeper.remains<1.1*gcd*buff.stormkeeper.stack)
 if buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) spell(lightning_bolt)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
 #flame_shock,target_if=(!ticking|dot.flame_shock.remains<=gcd|talent.ascendance.enabled&dot.flame_shock.remains<(cooldown.ascendance.remains+buff.ascendance.duration)&cooldown.ascendance.remains<4)&(buff.lava_surge.up|!buff.bloodlust.up)
 if { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } spell(flame_shock)
 #flame_shock,if=buff.primordial_wave.up,target_if=min:dot.flame_shock.remains,cycle_targets=1,target_if=refreshable
 if buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) spell(flame_shock)
 #lava_burst,if=buff.lava_surge.up&(runeforge.windspeakers_lava_resurgence.equipped|!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&(maelstrom<70)
 if hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 spell(elemental_blast)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) spell(lava_burst)
 #earthquake,if=buff.echoes_of_great_sundering.up&talent.master_of_the_elements.enabled&buff.master_of_the_elements.up
 if buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up&buff.master_of_the_elements.up&maelstrom<60
 if buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up&(talent.master_of_the_elements.enabled&(buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earthquake)
 #earthquake,if=spell_targets.chain_lightning>1&!dot.flame_shock.refreshable&!runeforge.echoes_of_great_sundering.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } spell(earthquake)
 #lava_burst,if=cooldown_react&(!buff.master_of_the_elements.up&buff.icefury.up)
 if not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled&!buff.icefury.up
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=talent.echo_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50&!buff.echoes_of_great_sundering.up
 if hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) spell(lava_burst)
 #earth_shock,if=(runeforge.echoes_of_great_sundering.equipped|spell_targets.chain_lightning<2)&(talent.master_of_the_elements.enabled&!buff.echoes_of_great_sundering.up&(buff.master_of_the_elements.up|maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earth_shock)
 #frost_shock,if=talent.icefury.enabled&talent.master_of_the_elements.enabled&buff.icefury.up&buff.master_of_the_elements.up
 if hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) spell(frost_shock)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react&!talent.master_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&(buff.icefury.remains<gcd*4*buff.icefury.stack|buff.stormkeeper.up|!talent.master_of_the_elements.enabled)
 if hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } spell(frost_shock)
 #lava_burst
 spell(lava_burst)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,if=runeforge.elemental_equilibrium.equipped&!buff.elemental_equilibrium_debuff.up&!talent.elemental_blast.enabled&!talent.echoing_shock.enabled
 if equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=spell_targets.chain_lightning>1
 if enemies(tagged=1) > 1 spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
}

AddFunction elementalsingle_targetmainpostconditions
{
}

AddFunction elementalsingle_targetshortcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)&(maelstrom<44)
  if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() spell(echoing_shock)

  unless hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst)
  {
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)

   unless buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst)
   {
    #icefury,if=talent.icefury.enabled&!(maelstrom>35&cooldown.lava_burst.remains<=0)
    if hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } spell(icefury)

    unless hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock)
    {
     #chain_harvest
     spell(chain_harvest)

     unless hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
     {
      #static_discharge,if=talent.static_discharge.enabled
      if hastalent(static_discharge_talent) spell(static_discharge)
     }
    }
   }
  }
 }
}

AddFunction elementalsingle_targetshortcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

AddFunction elementalsingle_targetcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(time>=60|buff.bloodlust.up)&(cooldown.lava_burst.remains>0)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and { timeincombat() >= 60 or buffpresent(bloodlust) } and spellcooldown(lava_burst) > 0 and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)

  unless buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless hastalent(static_discharge_talent) and spell(static_discharge)
   {
    #earth_elemental,if=!talent.primal_elementalist.enabled|!pet.fire_elemental.active
    if not hastalent(primal_elementalist_talent) or not pet.present() spell(earth_elemental)
   }
  }
 }
}

AddFunction elementalsingle_targetcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

### actions.se_single_target

AddFunction elementalse_single_targetmainactions
{
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack&buff.wind_gust.stack<18
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 spell(frost_shock)
 #elemental_blast,if=talent.elemental_blast.enabled
 if hastalent(elemental_blast_talent_elemental) spell(elemental_blast)
 #lava_burst,if=(buff.wind_gust.stack<18&!buff.bloodlust.up)|buff.lava_surge.up
 if buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) spell(lava_burst)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning<2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 spell(lava_burst)
 #earthquake,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning>=2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up
 if buffpresent(stormkeeper) spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up
 if buffpresent(echoes_of_great_sundering_buff) spell(earthquake)
 #earth_shock,if=spell_targets.chain_lightning<2&maelstrom>=60&(buff.wind_gust.stack<20|maelstrom>90)|(runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up)
 if enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #earthquake,if=(spell_targets.chain_lightning>1)&(!dot.flame_shock.refreshable)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) spell(earthquake)
 #chain_lightning,if=active_enemies>1&pet.storm_elemental.active&buff.bloodlust.up
 if enemies() > 1 and pet.present() and buffpresent(bloodlust) spell(chain_lightning)
 #lightning_bolt,if=pet.storm_elemental.active&buff.bloodlust.up
 if pet.present() and buffpresent(bloodlust) spell(lightning_bolt)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react
 if not spellcooldown(lava_burst) > 0 spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=active_enemies>1&(spell_targets.chain_lightning>1|spell_targets.lava_beam>1)
 if enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalse_single_targetmainpostconditions
{
}

AddFunction elementalse_single_targetshortcdactions
{
 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd&spell_targets.chain_lightning<2|maelstrom>=60&spell_targets.chain_lightning>=2&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)|spell_targets.chain_lightning<2&buff.wind_gust.stack>=18&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&maelstrom>=60
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 spell(echoing_shock)

  unless { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #chain_harvest
   spell(chain_harvest)
   #static_discharge,if=talent.static_discharge.enabled
   if hastalent(static_discharge_talent) spell(static_discharge)
  }
 }
}

AddFunction elementalse_single_targetshortcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalse_single_targetcdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest)
 {
  #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
  if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

  unless hastalent(static_discharge_talent) and spell(static_discharge)
  {
   #earth_elemental,if=!talent.primal_elementalist.enabled|talent.primal_elementalist.enabled&(!pet.storm_elemental.active)
   if not hastalent(primal_elementalist_talent) or hastalent(primal_elementalist_talent) and not pet.present() spell(earth_elemental)
  }
 }
}

AddFunction elementalse_single_targetcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.precombat

AddFunction elementalprecombatmainactions
{
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<3
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 spell(elemental_blast)
 #lava_burst,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning<3|buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) spell(lava_burst)
 #chain_lightning,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning>=3&!buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) spell(chain_lightning)
}

AddFunction elementalprecombatmainpostconditions
{
}

AddFunction elementalprecombatshortcdactions
{
 #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)
 if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } spell(stormkeeper)
}

AddFunction elementalprecombatshortcdpostconditions
{
 hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

AddFunction elementalprecombatcdactions
{
 #flask
 #food
 #augmentation
 #earth_elemental,if=!talent.primal_elementalist.enabled
 if not hastalent(primal_elementalist_talent) spell(earth_elemental)

 unless hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper)
 {
  #fire_elemental
  spell(fire_elemental)

  unless hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
  {
   #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
   if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
   #snapshot_stats
   #potion
   if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
  }
 }
}

AddFunction elementalprecombatcdpostconditions
{
 hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

### actions.aoe

AddFunction elementalaoemainactions
{
 #earthquake,if=buff.echoing_shock.up
 if buffpresent(echoing_shock) spell(earthquake)
 #flame_shock,if=(active_dot.flame_shock<2&active_enemies<=3&cooldown.primordial_wave.remains<16&covenant.necrolord&!pet.storm_elemental.active|active_dot.flame_shock<1&active_enemies>=4&!pet.storm_elemental.active&talent.master_of_the_elements.enabled)|(runeforge.skybreakers_fiery_demise.equipped&!pet.storm_elemental.active),target_if=refreshable
 if { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,if=!active_dot.flame_shock&!pet.storm_elemental.active&(talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #chain_lightning,if=spell_targets.chain_lightning<4&buff.master_of_the_elements.up&maelstrom<50
 if enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 spell(chain_lightning)
 #earth_shock,if=runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up
 if equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&(buff.lava_surge.up&!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2&!runeforge.echoes_of_great_sundering.equipped&(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up)
 if enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lava_burst,target_if=dot.flame_shock.remains,if=buff.lava_surge.up&buff.primordial_wave.up
 if target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=(spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&talent.master_of_the_elements.enabled)|(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&!runeforge.skybreakers_fiery_demise.equipped)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning=4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2
 if enemies(tagged=1) >= 2 spell(earthquake)
 #chain_lightning,if=buff.stormkeeper.remains<3*gcd*buff.stormkeeper.stack
 if buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) spell(chain_lightning)
 #lava_burst,if=buff.lava_surge.up&spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&dot.flame_shock.ticking
 if buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<5&(!pet.storm_elemental.active)
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() spell(elemental_blast)
 #lava_beam,if=talent.ascendance.enabled
 if hastalent(ascendance_talent) spell(lava_beam)
 #chain_lightning
 spell(chain_lightning)
 #lava_burst,moving=1,if=buff.lava_surge.up&cooldown_react
 if speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } spell(lava_burst)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalaoemainpostconditions
{
}

AddFunction elementalaoeshortcdactions
{
 unless buffpresent(echoing_shock) and spell(earthquake)
 {
  #chain_harvest
  spell(chain_harvest)
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)

  unless { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #echoing_shock,if=talent.echoing_shock.enabled&maelstrom>=60&(runeforge.echoes_of_great_sundering.equipped&buff.echoes_of_great_sundering.up|!runeforge.echoes_of_great_sundering.equipped)
   if hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } spell(echoing_shock)
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)
  }
 }
}

AddFunction elementalaoeshortcdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalaoecdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(!pet.storm_elemental.active)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and not pet.present() and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)
 }
}

AddFunction elementalaoecdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.default

AddFunction elemental_defaultmainactions
{
 #flame_shock,if=(!talent.elemental_blast.enabled)&!ticking&!pet.storm_elemental.active&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #flame_shock,if=!ticking&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20)&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
 if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoemainactions()

 unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions()
 {
  #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
  if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetmainactions()

  unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions()
  {
   #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
   if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetmainactions()
  }
 }
}

AddFunction elemental_defaultmainpostconditions
{
 enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetmainpostconditions()
}

AddFunction elemental_defaultshortcdactions
{
 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20|soulbind.lead_by_example.enabled)&(spell_targets.chain_lightning<5|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped|soulbind.lead_by_example.enabled)
  if not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } spell(primordial_wave)

  unless not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
   if not hastalent(ascendance_talent) or not buffpresent(ascendance) spell(bag_of_tricks)
   #vesper_totem,if=covenant.kyrian
   if iscovenant("kyrian") spell(vesper_totem)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoeshortcdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetshortcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetshortcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultshortcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetshortcdpostconditions()
}

AddFunction elemental_defaultcdactions
{
 #spiritwalkers_grace,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(spiritwalkers_grace)
 #wind_shear
 elementalinterruptactions()
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
 #use_items
 elementaluseitemactions()

 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #fire_elemental
  spell(fire_elemental)
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent) or buffpresent(ascendance) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem)
  {
   #fae_transfusion,if=covenant.night_fae&!runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up)&spell_targets.chain_lightning<3
   if iscovenant("night_fae") and not equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) } and enemies(tagged=1) < 3 spell(fae_transfusion)
   #fae_transfusion,if=covenant.night_fae&runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|spell_targets.chain_lightning>=3)&(cooldown.fire_elemental.remains>20|cooldown.storm_elemental.remains>20)
   if iscovenant("night_fae") and equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or enemies(tagged=1) >= 3 } and { spellcooldown(fire_elemental) > 20 or spellcooldown(storm_elemental) > 20 } spell(fae_transfusion)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoecdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetcdpostconditions()
}

### Elemental icons.

AddCheckBox(opt_shaman_elemental_aoe l(aoe) default enabled=(specialization(elemental)))

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(specialization(elemental)) enemies=1 help=main
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=aoe
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance
# ascendance_talent
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# earth_elemental
# earth_shock
# earthquake
# echo_of_the_elements_talent_elemental
# echoes_of_great_sundering_buff
# echoes_of_great_sundering_runeforge
# echoing_shock
# echoing_shock_talent
# elemental_blast
# elemental_blast_talent_elemental
# elemental_equilibrium_buff
# elemental_equilibrium_runeforge
# fae_transfusion
# fire_elemental
# fireblood
# flame_shock
# fleshcraft
# frost_shock
# hex
# icefury
# icefury_talent
# lava_beam
# lava_burst
# lava_surge_buff
# lead_by_example_soulbind
# lightning_bolt
# liquid_magma_totem
# liquid_magma_totem_talent
# master_of_the_elements_buff
# master_of_the_elements_talent
# potion_of_spectral_intellect_item
# primal_elementalist_talent
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# skybreakers_fiery_demise_runeforge
# spiritwalkers_grace
# static_discharge
# static_discharge_talent
# storm_elemental
# storm_elemental_talent
# stormkeeper
# stormkeeper_talent
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_gust_buff
# wind_shear
# windspeakers_lava_resurgence_runeforge
]]
        scripts:registerScript("SHAMAN", "elemental", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_elemental_venthyr"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Elemental_Venthyr"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Elemental_Venthyr".
#	class=shaman
#	spec=elemental
#	talents=2301032

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(elemental)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(elemental)))

AddFunction elementalinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction elementaluseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

### actions.single_target

AddFunction elementalsingle_targetmainactions
{
 #lightning_bolt,if=(buff.stormkeeper.remains<1.1*gcd*buff.stormkeeper.stack)
 if buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) spell(lightning_bolt)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
 #flame_shock,target_if=(!ticking|dot.flame_shock.remains<=gcd|talent.ascendance.enabled&dot.flame_shock.remains<(cooldown.ascendance.remains+buff.ascendance.duration)&cooldown.ascendance.remains<4)&(buff.lava_surge.up|!buff.bloodlust.up)
 if { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } spell(flame_shock)
 #flame_shock,if=buff.primordial_wave.up,target_if=min:dot.flame_shock.remains,cycle_targets=1,target_if=refreshable
 if buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) spell(flame_shock)
 #lava_burst,if=buff.lava_surge.up&(runeforge.windspeakers_lava_resurgence.equipped|!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&(maelstrom<70)
 if hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 spell(elemental_blast)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) spell(lava_burst)
 #earthquake,if=buff.echoes_of_great_sundering.up&talent.master_of_the_elements.enabled&buff.master_of_the_elements.up
 if buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up&buff.master_of_the_elements.up&maelstrom<60
 if buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up&(talent.master_of_the_elements.enabled&(buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earthquake)
 #earthquake,if=spell_targets.chain_lightning>1&!dot.flame_shock.refreshable&!runeforge.echoes_of_great_sundering.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|cooldown.lava_burst.remains>0&maelstrom>=92)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } spell(earthquake)
 #lava_burst,if=cooldown_react&(!buff.master_of_the_elements.up&buff.icefury.up)
 if not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled&!buff.icefury.up
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) spell(lava_burst)
 #lava_burst,if=talent.echo_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50&!buff.echoes_of_great_sundering.up
 if hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) spell(lava_burst)
 #earth_shock,if=(runeforge.echoes_of_great_sundering.equipped|spell_targets.chain_lightning<2)&(talent.master_of_the_elements.enabled&!buff.echoes_of_great_sundering.up&(buff.master_of_the_elements.up|maelstrom>=92|spell_targets.chain_lightning<2&buff.stormkeeper.up&cooldown.lava_burst.remains<=gcd)|!talent.master_of_the_elements.enabled|cooldown.elemental_blast.remains<=1.1*gcd*2)
 if { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } spell(earth_shock)
 #frost_shock,if=talent.icefury.enabled&talent.master_of_the_elements.enabled&buff.icefury.up&buff.master_of_the_elements.up
 if hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) spell(frost_shock)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react&!talent.master_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&(buff.icefury.remains<gcd*4*buff.icefury.stack|buff.stormkeeper.up|!talent.master_of_the_elements.enabled)
 if hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } spell(frost_shock)
 #lava_burst
 spell(lava_burst)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,if=runeforge.elemental_equilibrium.equipped&!buff.elemental_equilibrium_debuff.up&!talent.elemental_blast.enabled&!talent.echoing_shock.enabled
 if equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=spell_targets.chain_lightning>1
 if enemies(tagged=1) > 1 spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) spell(frost_shock)
}

AddFunction elementalsingle_targetmainpostconditions
{
}

AddFunction elementalsingle_targetshortcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)&(maelstrom<44)
  if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() spell(echoing_shock)

  unless hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst)
  {
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)

   unless buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst)
   {
    #icefury,if=talent.icefury.enabled&!(maelstrom>35&cooldown.lava_burst.remains<=0)
    if hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } spell(icefury)

    unless hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock)
    {
     #chain_harvest
     spell(chain_harvest)

     unless hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
     {
      #static_discharge,if=talent.static_discharge.enabled
      if hastalent(static_discharge_talent) spell(static_discharge)
     }
    }
   }
  }
 }
}

AddFunction elementalsingle_targetshortcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

AddFunction elementalsingle_targetcdactions
{
 unless buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(time>=60|buff.bloodlust.up)&(cooldown.lava_burst.remains>0)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and { timeincombat() >= 60 or buffpresent(bloodlust) } and spellcooldown(lava_burst) > 0 and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)

  unless buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless hastalent(static_discharge_talent) and spell(static_discharge)
   {
    #earth_elemental,if=!talent.primal_elementalist.enabled|!pet.fire_elemental.active
    if not hastalent(primal_elementalist_talent) or not pet.present() spell(earth_elemental)
   }
  }
 }
}

AddFunction elementalsingle_targetcdpostconditions
{
 buffremaining(stormkeeper) < 1.1 * gcd() * buffstacks(stormkeeper) and spell(lightning_bolt) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock) or { not target.debuffpresent(flame_shock) or target.debuffremaining(flame_shock) <= gcd() or hastalent(ascendance_talent) and target.debuffremaining(flame_shock) < spellcooldown(ascendance) + baseduration(ascendance) and spellcooldown(ascendance) < 4 } and { buffpresent(lava_surge_buff) or not buffpresent(bloodlust) } and spell(flame_shock) or buffpresent(primordial_wave_buff) and target.refreshable(flame_shock) and spell(flame_shock) or buffpresent(lava_surge_buff) and { equippedruneforge(windspeakers_lava_resurgence_runeforge) or not buffpresent(master_of_the_elements_buff) and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and maelstrom() < 70 and spell(elemental_blast) or hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and maelstrom() < 44 and spell(stormkeeper) or hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and spell(echoing_shock) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and spell(lava_burst) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or buffpresent(echoes_of_great_sundering_buff) and hastalent(master_of_the_elements_talent) and buffpresent(master_of_the_elements_buff) and spell(earthquake) or buffpresent(stormkeeper) and buffpresent(master_of_the_elements_buff) and maelstrom() < 60 and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and { hastalent(master_of_the_elements_talent) and { buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earthquake) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and not equippedruneforge(echoes_of_great_sundering_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or spellcooldown(lava_burst) > 0 and maelstrom() >= 92 } and spell(earthquake) or not spellcooldown(lava_burst) > 0 and not buffpresent(master_of_the_elements_buff) and buffpresent(icefury) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and not buffpresent(icefury) and spell(lava_burst) or hastalent(echo_of_the_elements_talent_elemental) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 and not buffpresent(echoes_of_great_sundering_buff) and spell(lava_burst) or { equippedruneforge(echoes_of_great_sundering_runeforge) or enemies(tagged=1) < 2 } and { hastalent(master_of_the_elements_talent) and not buffpresent(echoes_of_great_sundering_buff) and { buffpresent(master_of_the_elements_buff) or maelstrom() >= 92 or enemies(tagged=1) < 2 and buffpresent(stormkeeper) and spellcooldown(lava_burst) <= gcd() } or not hastalent(master_of_the_elements_talent) or spellcooldown(elemental_blast) <= 1.1 * gcd() * 2 } and spell(earth_shock) or hastalent(icefury_talent) and hastalent(master_of_the_elements_talent) and buffpresent(icefury) and buffpresent(master_of_the_elements_buff) and spell(frost_shock) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and not hastalent(master_of_the_elements_talent) and spell(lava_burst) or hastalent(icefury_talent) and not { maelstrom() > 35 and spellcooldown(lava_burst) <= 0 } and spell(icefury) or hastalent(icefury_talent) and buffpresent(icefury) and { buffremaining(icefury) < gcd() * 4 * buffstacks(icefury) or buffpresent(stormkeeper) or not hastalent(master_of_the_elements_talent) } and spell(frost_shock) or spell(lava_burst) or target.refreshable(flame_shock) and spell(flame_shock) or equippedruneforge(elemental_equilibrium_runeforge) and not buffpresent(elemental_equilibrium_buff) and not hastalent(elemental_blast_talent_elemental) and not hastalent(echoing_shock_talent) and spell(frost_shock) or spell(chain_harvest) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies(tagged=1) > 1 and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock) or hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and spell(frost_shock)
}

### actions.se_single_target

AddFunction elementalse_single_targetmainactions
{
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up&buff.icefury.remains<1.1*gcd*buff.icefury.stack&buff.wind_gust.stack<18
 if hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 spell(frost_shock)
 #elemental_blast,if=talent.elemental_blast.enabled
 if hastalent(elemental_blast_talent_elemental) spell(elemental_blast)
 #lava_burst,if=(buff.wind_gust.stack<18&!buff.bloodlust.up)|buff.lava_surge.up
 if buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) spell(lava_burst)
 #lava_burst,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning<2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 spell(lava_burst)
 #earthquake,if=talent.echoing_shock.enabled&buff.echoing_shock.up&spell_targets.chain_lightning>=2
 if hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 spell(earthquake)
 #lightning_bolt,if=buff.stormkeeper.up
 if buffpresent(stormkeeper) spell(lightning_bolt)
 #earthquake,if=buff.echoes_of_great_sundering.up
 if buffpresent(echoes_of_great_sundering_buff) spell(earthquake)
 #earth_shock,if=spell_targets.chain_lightning<2&maelstrom>=60&(buff.wind_gust.stack<20|maelstrom>90)|(runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up)
 if enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #earthquake,if=(spell_targets.chain_lightning>1)&(!dot.flame_shock.refreshable)
 if enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) spell(earthquake)
 #chain_lightning,if=active_enemies>1&pet.storm_elemental.active&buff.bloodlust.up
 if enemies() > 1 and pet.present() and buffpresent(bloodlust) spell(chain_lightning)
 #lightning_bolt,if=pet.storm_elemental.active&buff.bloodlust.up
 if pet.present() and buffpresent(bloodlust) spell(lightning_bolt)
 #lava_burst,if=buff.ascendance.up
 if buffpresent(ascendance) spell(lava_burst)
 #lava_burst,if=cooldown_react
 if not spellcooldown(lava_burst) > 0 spell(lava_burst)
 #lava_burst,if=cooldown_react&charges>talent.echo_of_the_elements.enabled
 if not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) spell(lava_burst)
 #frost_shock,if=talent.icefury.enabled&buff.icefury.up
 if hastalent(icefury_talent) and buffpresent(icefury) spell(frost_shock)
 #chain_lightning,if=active_enemies>1&(spell_targets.chain_lightning>1|spell_targets.lava_beam>1)
 if enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } spell(chain_lightning)
 #lightning_bolt
 spell(lightning_bolt)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalse_single_targetmainpostconditions
{
}

AddFunction elementalse_single_targetshortcdactions
{
 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)
  #echoing_shock,if=talent.echoing_shock.enabled&cooldown.lava_burst.remains<=gcd&spell_targets.chain_lightning<2|maelstrom>=60&spell_targets.chain_lightning>=2&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)|spell_targets.chain_lightning<2&buff.wind_gust.stack>=18&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&maelstrom>=60
  if hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 spell(echoing_shock)

  unless { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock)
  {
   #chain_harvest
   spell(chain_harvest)
   #static_discharge,if=talent.static_discharge.enabled
   if hastalent(static_discharge_talent) spell(static_discharge)
  }
 }
}

AddFunction elementalse_single_targetshortcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalse_single_targetcdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest)
 {
  #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
  if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

  unless hastalent(static_discharge_talent) and spell(static_discharge)
  {
   #earth_elemental,if=!talent.primal_elementalist.enabled|talent.primal_elementalist.enabled&(!pet.storm_elemental.active)
   if not hastalent(primal_elementalist_talent) or hastalent(primal_elementalist_talent) and not pet.present() spell(earth_elemental)
  }
 }
}

AddFunction elementalse_single_targetcdpostconditions
{
 hastalent(icefury_talent) and buffpresent(icefury) and buffremaining(icefury) < 1.1 * gcd() * buffstacks(icefury) and buffstacks(wind_gust_buff) < 18 and spell(frost_shock) or hastalent(elemental_blast_talent_elemental) and spell(elemental_blast) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { hastalent(echoing_shock_talent) and spellcooldown(lava_burst) <= gcd() and enemies(tagged=1) < 2 or maelstrom() >= 60 and enemies(tagged=1) >= 2 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } or enemies(tagged=1) < 2 and buffstacks(wind_gust_buff) >= 18 and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and maelstrom() >= 60 } and spell(echoing_shock) or { buffstacks(wind_gust_buff) < 18 and not buffpresent(bloodlust) or buffpresent(lava_surge_buff) } and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) < 2 and spell(lava_burst) or hastalent(echoing_shock_talent) and buffpresent(echoing_shock) and enemies(tagged=1) >= 2 and spell(earthquake) or buffpresent(stormkeeper) and spell(lightning_bolt) or buffpresent(echoes_of_great_sundering_buff) and spell(earthquake) or { enemies(tagged=1) < 2 and maelstrom() >= 60 and { buffstacks(wind_gust_buff) < 20 or maelstrom() > 90 } or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) } and spell(earth_shock) or enemies(tagged=1) > 1 and not target.debuffrefreshable(flame_shock) and spell(earthquake) or enemies() > 1 and pet.present() and buffpresent(bloodlust) and spell(chain_lightning) or pet.present() and buffpresent(bloodlust) and spell(lightning_bolt) or buffpresent(ascendance) and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and spell(lava_burst) or not spellcooldown(lava_burst) > 0 and charges(lava_burst) > talentpoints(echo_of_the_elements_talent_elemental) and spell(lava_burst) or hastalent(icefury_talent) and buffpresent(icefury) and spell(frost_shock) or spell(chain_harvest) or hastalent(static_discharge_talent) and spell(static_discharge) or enemies() > 1 and { enemies(tagged=1) > 1 or enemies(tagged=1) > 1 } and spell(chain_lightning) or spell(lightning_bolt) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and target.distance() > 6 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.precombat

AddFunction elementalprecombatmainactions
{
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<3
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 spell(elemental_blast)
 #lava_burst,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning<3|buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) spell(lava_burst)
 #chain_lightning,if=!talent.elemental_blast.enabled&spell_targets.chain_lightning>=3&!buff.stormkeeper.up
 if not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) spell(chain_lightning)
}

AddFunction elementalprecombatmainpostconditions
{
}

AddFunction elementalprecombatshortcdactions
{
 #stormkeeper,if=talent.stormkeeper.enabled&(raid_event.adds.count<3|raid_event.adds.in>50)
 if hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } spell(stormkeeper)
}

AddFunction elementalprecombatshortcdpostconditions
{
 hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

AddFunction elementalprecombatcdactions
{
 #flask
 #food
 #augmentation
 #earth_elemental,if=!talent.primal_elementalist.enabled
 if not hastalent(primal_elementalist_talent) spell(earth_elemental)

 unless hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper)
 {
  #fire_elemental
  spell(fire_elemental)

  unless hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
  {
   #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
   if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
   #snapshot_stats
   #potion
   if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
  }
 }
}

AddFunction elementalprecombatcdpostconditions
{
 hastalent(stormkeeper_talent) and { 0 < 3 or 600 > 50 } and spell(stormkeeper) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 and spell(elemental_blast) or { not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 3 or buffpresent(stormkeeper) } and spell(lava_burst) or not hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) >= 3 and not buffpresent(stormkeeper) and spell(chain_lightning)
}

### actions.aoe

AddFunction elementalaoemainactions
{
 #earthquake,if=buff.echoing_shock.up
 if buffpresent(echoing_shock) spell(earthquake)
 #flame_shock,if=(active_dot.flame_shock<2&active_enemies<=3&cooldown.primordial_wave.remains<16&covenant.necrolord&!pet.storm_elemental.active|active_dot.flame_shock<1&active_enemies>=4&!pet.storm_elemental.active&talent.master_of_the_elements.enabled)|(runeforge.skybreakers_fiery_demise.equipped&!pet.storm_elemental.active),target_if=refreshable
 if { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) spell(flame_shock)
 #flame_shock,if=!active_dot.flame_shock&!pet.storm_elemental.active&(talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #chain_lightning,if=spell_targets.chain_lightning<4&buff.master_of_the_elements.up&maelstrom<50
 if enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 spell(chain_lightning)
 #earth_shock,if=runeforge.echoes_of_great_sundering.equipped&!buff.echoes_of_great_sundering.up
 if equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) spell(earth_shock)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&(buff.lava_surge.up&!buff.master_of_the_elements.up&talent.master_of_the_elements.enabled)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2&!runeforge.echoes_of_great_sundering.equipped&(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up)
 if enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) spell(earthquake)
 #lava_burst,target_if=dot.flame_shock.remains,if=buff.lava_surge.up&buff.primordial_wave.up
 if target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=(spell_targets.chain_lightning<4&runeforge.skybreakers_fiery_demise.equipped&talent.master_of_the_elements.enabled)|(talent.master_of_the_elements.enabled&maelstrom>=50&!buff.master_of_the_elements.up&(!runeforge.echoes_of_great_sundering.equipped|buff.echoes_of_great_sundering.up)&!runeforge.skybreakers_fiery_demise.equipped)
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(lava_burst)
 #lava_burst,target_if=dot.flame_shock.remains,if=spell_targets.chain_lightning=4&runeforge.skybreakers_fiery_demise.equipped&buff.lava_surge.up&talent.master_of_the_elements.enabled&!buff.master_of_the_elements.up&maelstrom>=50
 if target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } spell(lava_burst)
 #earthquake,if=spell_targets.chain_lightning>=2
 if enemies(tagged=1) >= 2 spell(earthquake)
 #chain_lightning,if=buff.stormkeeper.remains<3*gcd*buff.stormkeeper.stack
 if buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) spell(chain_lightning)
 #lava_burst,if=buff.lava_surge.up&spell_targets.chain_lightning<4&(!pet.storm_elemental.active)&dot.flame_shock.ticking
 if buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) spell(lava_burst)
 #elemental_blast,if=talent.elemental_blast.enabled&spell_targets.chain_lightning<5&(!pet.storm_elemental.active)
 if hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() spell(elemental_blast)
 #lava_beam,if=talent.ascendance.enabled
 if hastalent(ascendance_talent) spell(lava_beam)
 #chain_lightning
 spell(chain_lightning)
 #lava_burst,moving=1,if=buff.lava_surge.up&cooldown_react
 if speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } spell(lava_burst)
 #flame_shock,moving=1,target_if=refreshable
 if speed() > 0 and target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction elementalaoemainpostconditions
{
}

AddFunction elementalaoeshortcdactions
{
 unless buffpresent(echoing_shock) and spell(earthquake)
 {
  #chain_harvest
  spell(chain_harvest)
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent) spell(stormkeeper)

  unless { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #echoing_shock,if=talent.echoing_shock.enabled&maelstrom>=60&(runeforge.echoes_of_great_sundering.equipped&buff.echoes_of_great_sundering.up|!runeforge.echoes_of_great_sundering.equipped)
   if hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } spell(echoing_shock)
   #liquid_magma_totem,if=talent.liquid_magma_totem.enabled
   if hastalent(liquid_magma_totem_talent) spell(liquid_magma_totem)
  }
 }
}

AddFunction elementalaoeshortcdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction elementalaoecdactions
{
 #storm_elemental
 spell(storm_elemental)

 unless buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock)
 {
  #ascendance,if=talent.ascendance.enabled&(!pet.storm_elemental.active)&(!talent.icefury.enabled|!buff.icefury.up&!cooldown.icefury.up)
  if hastalent(ascendance_talent) and not pet.present() and { not hastalent(icefury_talent) or not buffpresent(icefury) and not { not spellcooldown(icefury) > 0 } } spell(ascendance)
 }
}

AddFunction elementalaoecdpostconditions
{
 buffpresent(echoing_shock) and spell(earthquake) or spell(chain_harvest) or hastalent(stormkeeper_talent) and spell(stormkeeper) or { debuffcountonany(flame_shock) < 2 and enemies() <= 3 and spellcooldown(primordial_wave) < 16 and iscovenant("necrolord") and not pet.present() or debuffcountonany(flame_shock) < 1 and enemies() >= 4 and not pet.present() and hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) and not pet.present() } and target.refreshable(flame_shock) and spell(flame_shock) or not debuffcountonany(flame_shock) and not pet.present() and { hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or hastalent(echoing_shock_talent) and maelstrom() >= 60 and { equippedruneforge(echoes_of_great_sundering_runeforge) and buffpresent(echoes_of_great_sundering_buff) or not equippedruneforge(echoes_of_great_sundering_runeforge) } and spell(echoing_shock) or hastalent(liquid_magma_totem_talent) and spell(liquid_magma_totem) or enemies(tagged=1) < 4 and buffpresent(master_of_the_elements_buff) and maelstrom() < 50 and spell(chain_lightning) or equippedruneforge(echoes_of_great_sundering_runeforge) and not buffpresent(echoes_of_great_sundering_buff) and spell(earth_shock) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and not pet.present() and { buffpresent(lava_surge_buff) and not buffpresent(master_of_the_elements_buff) } and hastalent(master_of_the_elements_talent) } and spell(lava_burst) or enemies(tagged=1) >= 2 and not equippedruneforge(echoes_of_great_sundering_runeforge) and { hastalent(master_of_the_elements_talent) and maelstrom() >= 50 } and not buffpresent(master_of_the_elements_buff) and spell(earthquake) or target.debuffremaining(flame_shock) and { buffpresent(lava_surge_buff) and buffpresent(primordial_wave_buff) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) < 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and hastalent(master_of_the_elements_talent) or hastalent(master_of_the_elements_talent) and maelstrom() >= 50 and not buffpresent(master_of_the_elements_buff) and { not equippedruneforge(echoes_of_great_sundering_runeforge) or buffpresent(echoes_of_great_sundering_buff) } and not equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(lava_burst) or target.debuffremaining(flame_shock) and { enemies(tagged=1) == 4 and equippedruneforge(skybreakers_fiery_demise_runeforge) and buffpresent(lava_surge_buff) and hastalent(master_of_the_elements_talent) and not buffpresent(master_of_the_elements_buff) and maelstrom() >= 50 } and spell(lava_burst) or enemies(tagged=1) >= 2 and spell(earthquake) or buffremaining(stormkeeper) < 3 * gcd() * buffstacks(stormkeeper) and spell(chain_lightning) or buffpresent(lava_surge_buff) and enemies(tagged=1) < 4 and not pet.present() and target.debuffpresent(flame_shock) and spell(lava_burst) or hastalent(elemental_blast_talent_elemental) and enemies(tagged=1) < 5 and not pet.present() and spell(elemental_blast) or hastalent(ascendance_talent) and spell(lava_beam) or spell(chain_lightning) or speed() > 0 and { buffpresent(lava_surge_buff) and not spellcooldown(lava_burst) > 0 } and spell(lava_burst) or speed() > 0 and target.refreshable(flame_shock) and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### actions.default

AddFunction elemental_defaultmainactions
{
 #flame_shock,if=(!talent.elemental_blast.enabled)&!ticking&!pet.storm_elemental.active&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #flame_shock,if=!ticking&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20)&(spell_targets.chain_lightning<3|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped)
 if not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } spell(flame_shock)
 #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
 if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoemainactions()

 unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions()
 {
  #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
  if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetmainactions()

  unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions()
  {
   #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
   if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetmainactions()
  }
 }
}

AddFunction elemental_defaultmainpostconditions
{
 enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoemainpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetmainpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetmainpostconditions()
}

AddFunction elemental_defaultshortcdactions
{
 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up&(!pet.storm_elemental.active|spell_targets.chain_lightning<3&buff.wind_gust.stack<20|soulbind.lead_by_example.enabled)&(spell_targets.chain_lightning<5|talent.master_of_the_elements.enabled|runeforge.skybreakers_fiery_demise.equipped|soulbind.lead_by_example.enabled)
  if not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } spell(primordial_wave)

  unless not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
  {
   #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
   if not hastalent(ascendance_talent) or not buffpresent(ascendance) spell(bag_of_tricks)
   #vesper_totem,if=covenant.kyrian
   if iscovenant("kyrian") spell(vesper_totem)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoeshortcdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetshortcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetshortcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultshortcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoeshortcdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetshortcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetshortcdpostconditions()
}

AddFunction elemental_defaultcdactions
{
 #spiritwalkers_grace,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(spiritwalkers_grace)
 #wind_shear
 elementalinterruptactions()
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
 #use_items
 elementaluseitemactions()

 unless not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock)
 {
  #fire_elemental
  spell(fire_elemental)
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent) or buffpresent(ascendance) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent) or buffpresent(ascendance) or spellcooldown(ascendance) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem)
  {
   #fae_transfusion,if=covenant.night_fae&!runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up)&spell_targets.chain_lightning<3
   if iscovenant("night_fae") and not equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) } and enemies(tagged=1) < 3 spell(fae_transfusion)
   #fae_transfusion,if=covenant.night_fae&runeforge.seeds_of_rampant_growth.equipped&(!talent.master_of_the_elements.enabled|buff.master_of_the_elements.up|spell_targets.chain_lightning>=3)&(cooldown.fire_elemental.remains>20|cooldown.storm_elemental.remains>20)
   if iscovenant("night_fae") and equippedruneforge(seeds_of_rampant_growth_runeforge) and { not hastalent(master_of_the_elements_talent) or buffpresent(master_of_the_elements_buff) or enemies(tagged=1) >= 3 } and { spellcooldown(fire_elemental) > 20 or spellcooldown(storm_elemental) > 20 } spell(fae_transfusion)
   #run_action_list,name=aoe,if=active_enemies>2&(spell_targets.chain_lightning>2|spell_targets.lava_beam>2)
   if enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } elementalaoecdactions()

   unless enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions()
   {
    #run_action_list,name=single_target,if=!talent.storm_elemental.enabled&active_enemies<=2
    if not hastalent(storm_elemental_talent) and enemies() <= 2 elementalsingle_targetcdactions()

    unless not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions()
    {
     #run_action_list,name=se_single_target,if=talent.storm_elemental.enabled&active_enemies<=2
     if hastalent(storm_elemental_talent) and enemies() <= 2 elementalse_single_targetcdactions()
    }
   }
  }
 }
}

AddFunction elemental_defaultcdpostconditions
{
 not hastalent(elemental_blast_talent_elemental) and not target.debuffpresent(flame_shock) and not pet.present() and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 or enabledsoulbind(lead_by_example_soulbind) } and { enemies(tagged=1) < 5 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) or enabledsoulbind(lead_by_example_soulbind) } and spell(primordial_wave) or not target.debuffpresent(flame_shock) and { not pet.present() or enemies(tagged=1) < 3 and buffstacks(wind_gust_buff) < 20 } and { enemies(tagged=1) < 3 or hastalent(master_of_the_elements_talent) or equippedruneforge(skybreakers_fiery_demise_runeforge) } and spell(flame_shock) or { not hastalent(ascendance_talent) or not buffpresent(ascendance) } and spell(bag_of_tricks) or iscovenant("kyrian") and spell(vesper_totem) or enemies() > 2 and { enemies(tagged=1) > 2 or enemies(tagged=1) > 2 } and elementalaoecdpostconditions() or not hastalent(storm_elemental_talent) and enemies() <= 2 and elementalsingle_targetcdpostconditions() or hastalent(storm_elemental_talent) and enemies() <= 2 and elementalse_single_targetcdpostconditions()
}

### Elemental icons.

AddCheckBox(opt_shaman_elemental_aoe l(aoe) default enabled=(specialization(elemental)))

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=shortcd
{
 if not incombat() elementalprecombatshortcdactions()
 elemental_defaultshortcdactions()
}

AddIcon enabled=(specialization(elemental)) enemies=1 help=main
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=aoe
{
 if not incombat() elementalprecombatmainactions()
 elemental_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) enemies=1 help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_elemental_aoe) and specialization(elemental)) help=cd
{
 if not incombat() elementalprecombatcdactions()
 elemental_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance
# ascendance_talent
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# earth_elemental
# earth_shock
# earthquake
# echo_of_the_elements_talent_elemental
# echoes_of_great_sundering_buff
# echoes_of_great_sundering_runeforge
# echoing_shock
# echoing_shock_talent
# elemental_blast
# elemental_blast_talent_elemental
# elemental_equilibrium_buff
# elemental_equilibrium_runeforge
# fae_transfusion
# fire_elemental
# fireblood
# flame_shock
# fleshcraft
# frost_shock
# hex
# icefury
# icefury_talent
# lava_beam
# lava_burst
# lava_surge_buff
# lead_by_example_soulbind
# lightning_bolt
# liquid_magma_totem
# liquid_magma_totem_talent
# master_of_the_elements_buff
# master_of_the_elements_talent
# potion_of_spectral_intellect_item
# primal_elementalist_talent
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# skybreakers_fiery_demise_runeforge
# spiritwalkers_grace
# static_discharge
# static_discharge_talent
# storm_elemental
# storm_elemental_talent
# stormkeeper
# stormkeeper_talent
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_gust_buff
# wind_shear
# windspeakers_lava_resurgence_runeforge
]]
        scripts:registerScript("SHAMAN", "elemental", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_enhancement"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Enhancement"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Enhancement".
#	class=shaman
#	spec=enhancement
#	talents=3211131

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(enhancement)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(enhancement)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(enhancement)))
AddCheckBox(opt_bloodlust spellname(bloodlust) enabled=(specialization(enhancement)))

AddFunction enhancementinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if target.distance() < 5 and not target.classification(worldboss) spell(sundering)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction enhancementuseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

AddFunction enhancementbloodlust
{
 if checkboxon(opt_bloodlust) and debuffexpires(burst_haste_debuff any=1)
 {
  spell(bloodlust)
  spell(heroism)
 }
}

AddFunction enhancementgetinmeleerange
{
 if checkboxon(opt_melee_range) and not target.inrange(stormstrike)
 {
  if target.inrange(feral_lunge) spell(feral_lunge)
  texture(misc_arrowlup help=(l(not_in_melee_range)))
 }
}

### actions.single

AddFunction enhancementsinglemainactions
{
 #windstrike
 spell(windstrike)
 #lava_lash,if=buff.hot_hand.up|(runeforge.primal_lava_actuators.equipped&buff.primal_lava_actuators.stack>6)
 if buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 spell(lava_lash)
 #stormstrike,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(stormstrike)
 #crash_lightning,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(crash_lightning)
 #ice_strike,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(ice_strike)
 #flame_shock,if=!ticking
 if not target.debuffpresent(flame_shock) spell(flame_shock)
 #frost_shock,if=buff.hailstorm.up
 if buffpresent(hailstorm_buff) spell(frost_shock)
 #earthen_spike
 spell(earthen_spike)
 #chain_lightning,if=buff.stormkeeper.up
 if buffpresent(stormkeeper_enhancement) spell(chain_lightning)
 #elemental_blast,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(elemental_blast)
 #lightning_bolt,if=buff.maelstrom_weapon.stack=10
 if buffstacks(maelstrom_weapon_buff) == 10 spell(lightning_bolt)
 #stormstrike
 spell(stormstrike)
 #lava_lash
 spell(lava_lash)
 #crash_lightning
 spell(crash_lightning)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock
 spell(frost_shock)
 #ice_strike
 spell(ice_strike)
 #fire_nova,if=active_dot.flame_shock
 if debuffcountonany(flame_shock) spell(fire_nova)
 #lightning_bolt,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(lightning_bolt)
 #windfury_totem,if=buff.windfury_totem.remains<30
 if buffremaining(windfury_totem) < 30 spell(windfury_totem)
}

AddFunction enhancementsinglemainpostconditions
{
}

AddFunction enhancementsingleshortcdactions
{
 unless spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash)
 {
  #primordial_wave,if=!buff.primordial_wave.up
  if not buffpresent(primordial_wave_buff) spell(primordial_wave)

  unless equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike)
  {
   #sundering,if=runeforge.doom_winds.equipped&buff.doom_winds.up
   if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(sundering)

   unless not target.debuffpresent(flame_shock) and spell(flame_shock)
   {
    #vesper_totem
    spell(vesper_totem)

    unless buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast)
    {
     #chain_harvest,if=buff.maelstrom_weapon.stack>=5&raid_event.adds.in>=90
     if buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 spell(chain_harvest)

     unless buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike)
     {
      #stormkeeper,if=buff.maelstrom_weapon.stack>=5
      if buffstacks(maelstrom_weapon_buff) >= 5 spell(stormkeeper_enhancement)

      unless spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike)
      {
       #sundering,if=raid_event.adds.in>=40
       if 600 >= 40 spell(sundering)
      }
     }
    }
   }
  }
 }
}

AddFunction enhancementsingleshortcdpostconditions
{
 spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or not target.debuffpresent(flame_shock) and spell(flame_shock) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

AddFunction enhancementsinglecdactions
{
 unless spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(sundering) or not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(vesper_totem) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike)
 {
  #fae_transfusion,if=!runeforge.seeds_of_rampant_growth.equipped|cooldown.feral_spirit.remains>15
  if not equippedruneforge(seeds_of_rampant_growth_runeforge) or spellcooldown(feral_spirit) > 15 spell(fae_transfusion)

  unless buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or 600 >= 40 and spell(sundering) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt)
   {
    #fleshcraft,if=soulbind.pustule_eruption
    if soulbind(pustule_eruption_soulbind) spell(fleshcraft)
    #earth_elemental
    spell(earth_elemental)
   }
  }
 }
}

AddFunction enhancementsinglecdpostconditions
{
 spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(sundering) or not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(vesper_totem) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or 600 >= 40 and spell(sundering) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

### actions.precombat

AddFunction enhancementprecombatmainactions
{
 #flask
 #food
 #augmentation
 #windfury_weapon
 spell(windfury_weapon)
 #flametongue_weapon
 if buffexpires(flametongue_weapon) spell(flametongue_weapon)
 #lightning_shield
 if buffexpires(lightning_shield) spell(lightning_shield)
 #windfury_totem,if=!runeforge.doom_winds.equipped
 if not equippedruneforge(doom_winds_runeforge) spell(windfury_totem)
}

AddFunction enhancementprecombatmainpostconditions
{
}

AddFunction enhancementprecombatshortcdactions
{
 unless spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent_enhancement) spell(stormkeeper_enhancement)
 }
}

AddFunction enhancementprecombatshortcdpostconditions
{
 spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
}

AddFunction enhancementprecombatcdactions
{
 unless spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or hastalent(stormkeeper_talent_enhancement) and spell(stormkeeper_enhancement) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
 {
  #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
  if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
  #potion
  if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_agility_item usable=1)
 }
}

AddFunction enhancementprecombatcdpostconditions
{
 spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or hastalent(stormkeeper_talent_enhancement) and spell(stormkeeper_enhancement) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
}

### actions.aoe

AddFunction enhancementaoemainactions
{
 #windstrike,if=buff.crash_lightning.up
 if buffpresent(crash_lightning) spell(windstrike)
 #crash_lightning,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(crash_lightning)
 #frost_shock,if=buff.hailstorm.up
 if buffpresent(hailstorm_buff) spell(frost_shock)
 #flame_shock,target_if=refreshable,cycle_targets=1,if=talent.fire_nova.enabled|talent.lashing_flames.enabled|covenant.necrolord|runeforge.primal_lava_actuators.equipped
 if target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } spell(flame_shock)
 #fire_nova,if=active_dot.flame_shock>=3
 if debuffcountonany(flame_shock) >= 3 spell(fire_nova)
 #lightning_bolt,if=buff.primordial_wave.up&buff.maelstrom_weapon.stack>=5
 if buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 spell(lightning_bolt)
 #chain_lightning,if=buff.stormkeeper.up
 if buffpresent(stormkeeper_enhancement) spell(chain_lightning)
 #crash_lightning,if=talent.crashing_storm.enabled|buff.crash_lightning.down
 if hastalent(crashing_storm_talent) or buffexpires(crash_lightning) spell(crash_lightning)
 #lava_lash,target_if=min:debuff.lashing_flames.remains,cycle_targets=1,if=talent.lashing_flames.enabled
 if hastalent(lashing_flames_talent) spell(lava_lash)
 #lava_lash,if=buff.crash_lightning.up&(buff.hot_hand.up|(runeforge.primal_lava_actuators.equipped&buff.primal_lava_actuators.stack>6))
 if buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } spell(lava_lash)
 #stormstrike,if=buff.crash_lightning.up
 if buffpresent(crash_lightning) spell(stormstrike)
 #crash_lightning
 spell(crash_lightning)
 #elemental_blast,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(elemental_blast)
 #chain_lightning,if=buff.maelstrom_weapon.stack=10
 if buffstacks(maelstrom_weapon_buff) == 10 spell(chain_lightning)
 #windstrike
 spell(windstrike)
 #stormstrike
 spell(stormstrike)
 #lava_lash
 spell(lava_lash)
 #flame_shock,target_if=refreshable,cycle_targets=1
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock
 spell(frost_shock)
 #ice_strike
 spell(ice_strike)
 #chain_lightning,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(chain_lightning)
 #fire_nova,if=active_dot.flame_shock>1
 if debuffcountonany(flame_shock) > 1 spell(fire_nova)
 #earthen_spike
 spell(earthen_spike)
 #windfury_totem,if=buff.windfury_totem.remains<30
 if buffremaining(windfury_totem) < 30 spell(windfury_totem)
}

AddFunction enhancementaoemainpostconditions
{
}

AddFunction enhancementaoeshortcdactions
{
 unless buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock)
 {
  #sundering
  spell(sundering)

  unless target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock)
  {
   #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up
   if not buffpresent(primordial_wave_buff) spell(primordial_wave)

   unless debuffcountonany(flame_shock) >= 3 and spell(fire_nova)
   {
    #vesper_totem
    spell(vesper_totem)

    unless buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning)
    {
     #chain_harvest,if=buff.maelstrom_weapon.stack>=5
     if buffstacks(maelstrom_weapon_buff) >= 5 spell(chain_harvest)

     unless buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast)
     {
      #stormkeeper,if=buff.maelstrom_weapon.stack>=5
      if buffstacks(maelstrom_weapon_buff) >= 5 spell(stormkeeper_enhancement)
     }
    }
   }
  }
 }
}

AddFunction enhancementaoeshortcdpostconditions
{
 buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

AddFunction enhancementaoecdactions
{
 unless buffpresent(crash_lightning) and spell(windstrike)
 {
  #fae_transfusion,if=soulbind.grove_invigoration|soulbind.field_of_blossoms
  if soulbind(grove_invigoration_soulbind) or soulbind(field_of_blossoms_soulbind) spell(fae_transfusion)

  unless equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(sundering) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or spell(vesper_totem) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless target.refreshable(flame_shock) and spell(flame_shock)
   {
    #fae_transfusion
    spell(fae_transfusion)

    unless spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike)
    {
     #earth_elemental
     spell(earth_elemental)
    }
   }
  }
 }
}

AddFunction enhancementaoecdpostconditions
{
 buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(sundering) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or spell(vesper_totem) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

### actions.default

AddFunction enhancement_defaultmainactions
{
 #heart_essence
 if hasequippeditem(158075) and level() < 50 spell(296208)
 #windfury_totem,if=runeforge.doom_winds.equipped&buff.doom_winds_debuff.down&(raid_event.adds.in>=60|active_enemies>1)
 if equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } spell(windfury_totem)
 #call_action_list,name=single,if=active_enemies=1
 if enemies() == 1 enhancementsinglemainactions()

 unless enemies() == 1 and enhancementsinglemainpostconditions()
 {
  #call_action_list,name=aoe,if=active_enemies>1
  if enemies() > 1 enhancementaoemainactions()
 }
}

AddFunction enhancement_defaultmainpostconditions
{
 enemies() == 1 and enhancementsinglemainpostconditions() or enemies() > 1 and enhancementaoemainpostconditions()
}

AddFunction enhancement_defaultshortcdactions
{
 #auto_attack
 enhancementgetinmeleerange()

 unless hasequippeditem(158075) and level() < 50 and spell(296208)
 {
  #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
  if not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) spell(bag_of_tricks)

  unless equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem)
  {
   #call_action_list,name=single,if=active_enemies=1
   if enemies() == 1 enhancementsingleshortcdactions()

   unless enemies() == 1 and enhancementsingleshortcdpostconditions()
   {
    #call_action_list,name=aoe,if=active_enemies>1
    if enemies() > 1 enhancementaoeshortcdactions()
   }
  }
 }
}

AddFunction enhancement_defaultshortcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208) or equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem) or enemies() == 1 and enhancementsingleshortcdpostconditions() or enemies() > 1 and enhancementaoeshortcdpostconditions()
}

AddFunction enhancement_defaultcdactions
{
 #bloodlust
 enhancementbloodlust()
 #potion,if=expected_combat_length-time<60
 if expectedcombatlength() - timeincombat() < 60 and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_agility_item usable=1)
 #wind_shear
 enhancementinterruptactions()

 unless hasequippeditem(158075) and level() < 50 and spell(296208)
 {
  #use_items
  enhancementuseitemactions()
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) } and spell(bag_of_tricks)
  {
   #feral_spirit
   spell(feral_spirit)
   #fae_transfusion,if=(talent.ascendance.enabled|runeforge.doom_winds.equipped)&(soulbind.grove_invigoration|soulbind.field_of_blossoms|active_enemies=1)
   if { hastalent(ascendance_talent_enhancement) or equippedruneforge(doom_winds_runeforge) } and { soulbind(grove_invigoration_soulbind) or soulbind(field_of_blossoms_soulbind) or enemies() == 1 } spell(fae_transfusion)
   #ascendance,if=raid_event.adds.in>=90|active_enemies>1
   if { 600 >= 90 or enemies() > 1 } and buffexpires(ascendance_enhancement) spell(ascendance_enhancement)

   unless equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem)
   {
    #call_action_list,name=single,if=active_enemies=1
    if enemies() == 1 enhancementsinglecdactions()

    unless enemies() == 1 and enhancementsinglecdpostconditions()
    {
     #call_action_list,name=aoe,if=active_enemies>1
     if enemies() > 1 enhancementaoecdactions()
    }
   }
  }
 }
}

AddFunction enhancement_defaultcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208) or { not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) } and spell(bag_of_tricks) or equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem) or enemies() == 1 and enhancementsinglecdpostconditions() or enemies() > 1 and enhancementaoecdpostconditions()
}

### Enhancement icons.

AddCheckBox(opt_shaman_enhancement_aoe l(aoe) default enabled=(specialization(enhancement)))

AddIcon enabled=(not checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) enemies=1 help=shortcd
{
 if not incombat() enhancementprecombatshortcdactions()
 enhancement_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=shortcd
{
 if not incombat() enhancementprecombatshortcdactions()
 enhancement_defaultshortcdactions()
}

AddIcon enabled=(specialization(enhancement)) enemies=1 help=main
{
 if not incombat() enhancementprecombatmainactions()
 enhancement_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=aoe
{
 if not incombat() enhancementprecombatmainactions()
 enhancement_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) enemies=1 help=cd
{
 if not incombat() enhancementprecombatcdactions()
 enhancement_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=cd
{
 if not incombat() enhancementprecombatcdactions()
 enhancement_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance_enhancement
# ascendance_talent_enhancement
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# crash_lightning
# crashing_storm_talent
# doom_winds
# doom_winds_buff
# doom_winds_runeforge
# earth_elemental
# earthen_spike
# elemental_blast
# fae_transfusion
# feral_lunge
# feral_spirit
# field_of_blossoms_soulbind
# fire_nova
# fire_nova_talent
# fireblood
# flame_shock
# flametongue_weapon
# fleshcraft
# frost_shock
# grove_invigoration_soulbind
# hailstorm_buff
# heroism
# hex
# hot_hand_buff
# ice_strike
# lashing_flames_talent
# lava_lash
# lightning_bolt
# lightning_shield
# maelstrom_weapon_buff
# potion_of_spectral_agility_item
# primal_lava_actuators_buff
# primal_lava_actuators_runeforge
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# stormkeeper_enhancement
# stormkeeper_talent_enhancement
# stormstrike
# sundering
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_shear
# windfury_totem
# windfury_weapon
# windstrike
]]
        scripts:registerScript("SHAMAN", "enhancement", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_enhancement_sorg"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Enhancement_SORG"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Enhancement_SORG".
#	class=shaman
#	spec=enhancement
#	talents=3211131

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(enhancement)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(enhancement)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(enhancement)))
AddCheckBox(opt_bloodlust spellname(bloodlust) enabled=(specialization(enhancement)))

AddFunction enhancementinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if target.distance() < 5 and not target.classification(worldboss) spell(sundering)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction enhancementuseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

AddFunction enhancementbloodlust
{
 if checkboxon(opt_bloodlust) and debuffexpires(burst_haste_debuff any=1)
 {
  spell(bloodlust)
  spell(heroism)
 }
}

AddFunction enhancementgetinmeleerange
{
 if checkboxon(opt_melee_range) and not target.inrange(stormstrike)
 {
  if target.inrange(feral_lunge) spell(feral_lunge)
  texture(misc_arrowlup help=(l(not_in_melee_range)))
 }
}

### actions.single

AddFunction enhancementsinglemainactions
{
 #windstrike
 spell(windstrike)
 #lava_lash,if=buff.hot_hand.up|(runeforge.primal_lava_actuators.equipped&buff.primal_lava_actuators.stack>6)
 if buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 spell(lava_lash)
 #stormstrike,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(stormstrike)
 #crash_lightning,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(crash_lightning)
 #ice_strike,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(ice_strike)
 #flame_shock,if=!ticking
 if not target.debuffpresent(flame_shock) spell(flame_shock)
 #frost_shock,if=buff.hailstorm.up
 if buffpresent(hailstorm_buff) spell(frost_shock)
 #earthen_spike
 spell(earthen_spike)
 #chain_lightning,if=buff.stormkeeper.up
 if buffpresent(stormkeeper_enhancement) spell(chain_lightning)
 #elemental_blast,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(elemental_blast)
 #lightning_bolt,if=buff.maelstrom_weapon.stack=10
 if buffstacks(maelstrom_weapon_buff) == 10 spell(lightning_bolt)
 #stormstrike
 spell(stormstrike)
 #lava_lash
 spell(lava_lash)
 #crash_lightning
 spell(crash_lightning)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock
 spell(frost_shock)
 #ice_strike
 spell(ice_strike)
 #fire_nova,if=active_dot.flame_shock
 if debuffcountonany(flame_shock) spell(fire_nova)
 #lightning_bolt,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(lightning_bolt)
 #windfury_totem,if=buff.windfury_totem.remains<30
 if buffremaining(windfury_totem) < 30 spell(windfury_totem)
}

AddFunction enhancementsinglemainpostconditions
{
}

AddFunction enhancementsingleshortcdactions
{
 unless spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash)
 {
  #primordial_wave,if=!buff.primordial_wave.up
  if not buffpresent(primordial_wave_buff) spell(primordial_wave)

  unless equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike)
  {
   #sundering,if=runeforge.doom_winds.equipped&buff.doom_winds.up
   if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(sundering)

   unless not target.debuffpresent(flame_shock) and spell(flame_shock)
   {
    #vesper_totem
    spell(vesper_totem)

    unless buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast)
    {
     #chain_harvest,if=buff.maelstrom_weapon.stack>=5&raid_event.adds.in>=90
     if buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 spell(chain_harvest)

     unless buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike)
     {
      #stormkeeper,if=buff.maelstrom_weapon.stack>=5
      if buffstacks(maelstrom_weapon_buff) >= 5 spell(stormkeeper_enhancement)

      unless spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike)
      {
       #sundering,if=raid_event.adds.in>=40
       if 600 >= 40 spell(sundering)
      }
     }
    }
   }
  }
 }
}

AddFunction enhancementsingleshortcdpostconditions
{
 spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or not target.debuffpresent(flame_shock) and spell(flame_shock) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

AddFunction enhancementsinglecdactions
{
 unless spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(sundering) or not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(vesper_totem) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike)
 {
  #fae_transfusion,if=!runeforge.seeds_of_rampant_growth.equipped|cooldown.feral_spirit.remains>15
  if not equippedruneforge(seeds_of_rampant_growth_runeforge) or spellcooldown(feral_spirit) > 15 spell(fae_transfusion)

  unless buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or 600 >= 40 and spell(sundering) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt)
   {
    #fleshcraft,if=soulbind.pustule_eruption
    if soulbind(pustule_eruption_soulbind) spell(fleshcraft)
    #earth_elemental
    spell(earth_elemental)
   }
  }
 }
}

AddFunction enhancementsinglecdpostconditions
{
 spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(sundering) or not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(vesper_totem) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or 600 >= 40 and spell(sundering) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

### actions.precombat

AddFunction enhancementprecombatmainactions
{
 #flask
 #food
 #augmentation
 #windfury_weapon
 spell(windfury_weapon)
 #flametongue_weapon
 if buffexpires(flametongue_weapon) spell(flametongue_weapon)
 #lightning_shield
 if buffexpires(lightning_shield) spell(lightning_shield)
 #windfury_totem,if=!runeforge.doom_winds.equipped
 if not equippedruneforge(doom_winds_runeforge) spell(windfury_totem)
}

AddFunction enhancementprecombatmainpostconditions
{
}

AddFunction enhancementprecombatshortcdactions
{
 unless spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent_enhancement) spell(stormkeeper_enhancement)
 }
}

AddFunction enhancementprecombatshortcdpostconditions
{
 spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
}

AddFunction enhancementprecombatcdactions
{
 unless spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or hastalent(stormkeeper_talent_enhancement) and spell(stormkeeper_enhancement) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
 {
  #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
  if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
  #potion
  if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_agility_item usable=1)
 }
}

AddFunction enhancementprecombatcdpostconditions
{
 spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or hastalent(stormkeeper_talent_enhancement) and spell(stormkeeper_enhancement) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
}

### actions.aoe

AddFunction enhancementaoemainactions
{
 #windstrike,if=buff.crash_lightning.up
 if buffpresent(crash_lightning) spell(windstrike)
 #crash_lightning,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(crash_lightning)
 #frost_shock,if=buff.hailstorm.up
 if buffpresent(hailstorm_buff) spell(frost_shock)
 #flame_shock,target_if=refreshable,cycle_targets=1,if=talent.fire_nova.enabled|talent.lashing_flames.enabled|covenant.necrolord|runeforge.primal_lava_actuators.equipped
 if target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } spell(flame_shock)
 #fire_nova,if=active_dot.flame_shock>=3
 if debuffcountonany(flame_shock) >= 3 spell(fire_nova)
 #lightning_bolt,if=buff.primordial_wave.up&buff.maelstrom_weapon.stack>=5
 if buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 spell(lightning_bolt)
 #chain_lightning,if=buff.stormkeeper.up
 if buffpresent(stormkeeper_enhancement) spell(chain_lightning)
 #crash_lightning,if=talent.crashing_storm.enabled|buff.crash_lightning.down
 if hastalent(crashing_storm_talent) or buffexpires(crash_lightning) spell(crash_lightning)
 #lava_lash,target_if=min:debuff.lashing_flames.remains,cycle_targets=1,if=talent.lashing_flames.enabled
 if hastalent(lashing_flames_talent) spell(lava_lash)
 #lava_lash,if=buff.crash_lightning.up&(buff.hot_hand.up|(runeforge.primal_lava_actuators.equipped&buff.primal_lava_actuators.stack>6))
 if buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } spell(lava_lash)
 #stormstrike,if=buff.crash_lightning.up
 if buffpresent(crash_lightning) spell(stormstrike)
 #crash_lightning
 spell(crash_lightning)
 #elemental_blast,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(elemental_blast)
 #chain_lightning,if=buff.maelstrom_weapon.stack=10
 if buffstacks(maelstrom_weapon_buff) == 10 spell(chain_lightning)
 #windstrike
 spell(windstrike)
 #stormstrike
 spell(stormstrike)
 #lava_lash
 spell(lava_lash)
 #flame_shock,target_if=refreshable,cycle_targets=1
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock
 spell(frost_shock)
 #ice_strike
 spell(ice_strike)
 #chain_lightning,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(chain_lightning)
 #fire_nova,if=active_dot.flame_shock>1
 if debuffcountonany(flame_shock) > 1 spell(fire_nova)
 #earthen_spike
 spell(earthen_spike)
 #windfury_totem,if=buff.windfury_totem.remains<30
 if buffremaining(windfury_totem) < 30 spell(windfury_totem)
}

AddFunction enhancementaoemainpostconditions
{
}

AddFunction enhancementaoeshortcdactions
{
 unless buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock)
 {
  #sundering
  spell(sundering)

  unless target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock)
  {
   #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up
   if not buffpresent(primordial_wave_buff) spell(primordial_wave)

   unless debuffcountonany(flame_shock) >= 3 and spell(fire_nova)
   {
    #vesper_totem
    spell(vesper_totem)

    unless buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning)
    {
     #chain_harvest,if=buff.maelstrom_weapon.stack>=5
     if buffstacks(maelstrom_weapon_buff) >= 5 spell(chain_harvest)

     unless buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast)
     {
      #stormkeeper,if=buff.maelstrom_weapon.stack>=5
      if buffstacks(maelstrom_weapon_buff) >= 5 spell(stormkeeper_enhancement)
     }
    }
   }
  }
 }
}

AddFunction enhancementaoeshortcdpostconditions
{
 buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

AddFunction enhancementaoecdactions
{
 unless buffpresent(crash_lightning) and spell(windstrike)
 {
  #fae_transfusion,if=soulbind.grove_invigoration|soulbind.field_of_blossoms
  if soulbind(grove_invigoration_soulbind) or soulbind(field_of_blossoms_soulbind) spell(fae_transfusion)

  unless equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(sundering) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or spell(vesper_totem) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless target.refreshable(flame_shock) and spell(flame_shock)
   {
    #fae_transfusion
    spell(fae_transfusion)

    unless spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike)
    {
     #earth_elemental
     spell(earth_elemental)
    }
   }
  }
 }
}

AddFunction enhancementaoecdpostconditions
{
 buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(sundering) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or spell(vesper_totem) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

### actions.default

AddFunction enhancement_defaultmainactions
{
 #heart_essence
 if hasequippeditem(158075) and level() < 50 spell(296208)
 #windfury_totem,if=runeforge.doom_winds.equipped&buff.doom_winds_debuff.down&(raid_event.adds.in>=60|active_enemies>1)
 if equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } spell(windfury_totem)
 #call_action_list,name=single,if=active_enemies=1
 if enemies() == 1 enhancementsinglemainactions()

 unless enemies() == 1 and enhancementsinglemainpostconditions()
 {
  #call_action_list,name=aoe,if=active_enemies>1
  if enemies() > 1 enhancementaoemainactions()
 }
}

AddFunction enhancement_defaultmainpostconditions
{
 enemies() == 1 and enhancementsinglemainpostconditions() or enemies() > 1 and enhancementaoemainpostconditions()
}

AddFunction enhancement_defaultshortcdactions
{
 #auto_attack
 enhancementgetinmeleerange()

 unless hasequippeditem(158075) and level() < 50 and spell(296208)
 {
  #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
  if not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) spell(bag_of_tricks)

  unless equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem)
  {
   #call_action_list,name=single,if=active_enemies=1
   if enemies() == 1 enhancementsingleshortcdactions()

   unless enemies() == 1 and enhancementsingleshortcdpostconditions()
   {
    #call_action_list,name=aoe,if=active_enemies>1
    if enemies() > 1 enhancementaoeshortcdactions()
   }
  }
 }
}

AddFunction enhancement_defaultshortcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208) or equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem) or enemies() == 1 and enhancementsingleshortcdpostconditions() or enemies() > 1 and enhancementaoeshortcdpostconditions()
}

AddFunction enhancement_defaultcdactions
{
 #bloodlust
 enhancementbloodlust()
 #potion,if=expected_combat_length-time<60
 if expectedcombatlength() - timeincombat() < 60 and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_agility_item usable=1)
 #wind_shear
 enhancementinterruptactions()

 unless hasequippeditem(158075) and level() < 50 and spell(296208)
 {
  #use_items
  enhancementuseitemactions()
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) } and spell(bag_of_tricks)
  {
   #feral_spirit
   spell(feral_spirit)
   #fae_transfusion,if=(talent.ascendance.enabled|runeforge.doom_winds.equipped)&(soulbind.grove_invigoration|soulbind.field_of_blossoms|active_enemies=1)
   if { hastalent(ascendance_talent_enhancement) or equippedruneforge(doom_winds_runeforge) } and { soulbind(grove_invigoration_soulbind) or soulbind(field_of_blossoms_soulbind) or enemies() == 1 } spell(fae_transfusion)
   #ascendance,if=raid_event.adds.in>=90|active_enemies>1
   if { 600 >= 90 or enemies() > 1 } and buffexpires(ascendance_enhancement) spell(ascendance_enhancement)

   unless equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem)
   {
    #call_action_list,name=single,if=active_enemies=1
    if enemies() == 1 enhancementsinglecdactions()

    unless enemies() == 1 and enhancementsinglecdpostconditions()
    {
     #call_action_list,name=aoe,if=active_enemies>1
     if enemies() > 1 enhancementaoecdactions()
    }
   }
  }
 }
}

AddFunction enhancement_defaultcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208) or { not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) } and spell(bag_of_tricks) or equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem) or enemies() == 1 and enhancementsinglecdpostconditions() or enemies() > 1 and enhancementaoecdpostconditions()
}

### Enhancement icons.

AddCheckBox(opt_shaman_enhancement_aoe l(aoe) default enabled=(specialization(enhancement)))

AddIcon enabled=(not checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) enemies=1 help=shortcd
{
 if not incombat() enhancementprecombatshortcdactions()
 enhancement_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=shortcd
{
 if not incombat() enhancementprecombatshortcdactions()
 enhancement_defaultshortcdactions()
}

AddIcon enabled=(specialization(enhancement)) enemies=1 help=main
{
 if not incombat() enhancementprecombatmainactions()
 enhancement_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=aoe
{
 if not incombat() enhancementprecombatmainactions()
 enhancement_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) enemies=1 help=cd
{
 if not incombat() enhancementprecombatcdactions()
 enhancement_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=cd
{
 if not incombat() enhancementprecombatcdactions()
 enhancement_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance_enhancement
# ascendance_talent_enhancement
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# crash_lightning
# crashing_storm_talent
# doom_winds
# doom_winds_buff
# doom_winds_runeforge
# earth_elemental
# earthen_spike
# elemental_blast
# fae_transfusion
# feral_lunge
# feral_spirit
# field_of_blossoms_soulbind
# fire_nova
# fire_nova_talent
# fireblood
# flame_shock
# flametongue_weapon
# fleshcraft
# frost_shock
# grove_invigoration_soulbind
# hailstorm_buff
# heroism
# hex
# hot_hand_buff
# ice_strike
# lashing_flames_talent
# lava_lash
# lightning_bolt
# lightning_shield
# maelstrom_weapon_buff
# potion_of_spectral_agility_item
# primal_lava_actuators_buff
# primal_lava_actuators_runeforge
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# stormkeeper_enhancement
# stormkeeper_talent_enhancement
# stormstrike
# sundering
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_shear
# windfury_totem
# windfury_weapon
# windstrike
]]
        scripts:registerScript("SHAMAN", "enhancement", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_enhancement_vdw"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Enhancement_VDW"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Enhancement_VDW".
#	class=shaman
#	spec=enhancement
#	talents=2111133

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(enhancement)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(enhancement)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(enhancement)))
AddCheckBox(opt_bloodlust spellname(bloodlust) enabled=(specialization(enhancement)))

AddFunction enhancementinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if target.distance() < 5 and not target.classification(worldboss) spell(sundering)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction enhancementuseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

AddFunction enhancementbloodlust
{
 if checkboxon(opt_bloodlust) and debuffexpires(burst_haste_debuff any=1)
 {
  spell(bloodlust)
  spell(heroism)
 }
}

AddFunction enhancementgetinmeleerange
{
 if checkboxon(opt_melee_range) and not target.inrange(stormstrike)
 {
  if target.inrange(feral_lunge) spell(feral_lunge)
  texture(misc_arrowlup help=(l(not_in_melee_range)))
 }
}

### actions.single

AddFunction enhancementsinglemainactions
{
 #windstrike
 spell(windstrike)
 #lava_lash,if=buff.hot_hand.up|(runeforge.primal_lava_actuators.equipped&buff.primal_lava_actuators.stack>6)
 if buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 spell(lava_lash)
 #stormstrike,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(stormstrike)
 #crash_lightning,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(crash_lightning)
 #ice_strike,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(ice_strike)
 #flame_shock,if=!ticking
 if not target.debuffpresent(flame_shock) spell(flame_shock)
 #frost_shock,if=buff.hailstorm.up
 if buffpresent(hailstorm_buff) spell(frost_shock)
 #earthen_spike
 spell(earthen_spike)
 #chain_lightning,if=buff.stormkeeper.up
 if buffpresent(stormkeeper_enhancement) spell(chain_lightning)
 #elemental_blast,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(elemental_blast)
 #lightning_bolt,if=buff.maelstrom_weapon.stack=10
 if buffstacks(maelstrom_weapon_buff) == 10 spell(lightning_bolt)
 #stormstrike
 spell(stormstrike)
 #lava_lash
 spell(lava_lash)
 #crash_lightning
 spell(crash_lightning)
 #flame_shock,target_if=refreshable
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock
 spell(frost_shock)
 #ice_strike
 spell(ice_strike)
 #fire_nova,if=active_dot.flame_shock
 if debuffcountonany(flame_shock) spell(fire_nova)
 #lightning_bolt,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(lightning_bolt)
 #windfury_totem,if=buff.windfury_totem.remains<30
 if buffremaining(windfury_totem) < 30 spell(windfury_totem)
}

AddFunction enhancementsinglemainpostconditions
{
}

AddFunction enhancementsingleshortcdactions
{
 unless spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash)
 {
  #primordial_wave,if=!buff.primordial_wave.up
  if not buffpresent(primordial_wave_buff) spell(primordial_wave)

  unless equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike)
  {
   #sundering,if=runeforge.doom_winds.equipped&buff.doom_winds.up
   if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(sundering)

   unless not target.debuffpresent(flame_shock) and spell(flame_shock)
   {
    #vesper_totem
    spell(vesper_totem)

    unless buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast)
    {
     #chain_harvest,if=buff.maelstrom_weapon.stack>=5&raid_event.adds.in>=90
     if buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 spell(chain_harvest)

     unless buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike)
     {
      #stormkeeper,if=buff.maelstrom_weapon.stack>=5
      if buffstacks(maelstrom_weapon_buff) >= 5 spell(stormkeeper_enhancement)

      unless spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike)
      {
       #sundering,if=raid_event.adds.in>=40
       if 600 >= 40 spell(sundering)
      }
     }
    }
   }
  }
 }
}

AddFunction enhancementsingleshortcdpostconditions
{
 spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or not target.debuffpresent(flame_shock) and spell(flame_shock) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

AddFunction enhancementsinglecdactions
{
 unless spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(sundering) or not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(vesper_totem) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike)
 {
  #fae_transfusion,if=!runeforge.seeds_of_rampant_growth.equipped|cooldown.feral_spirit.remains>15
  if not equippedruneforge(seeds_of_rampant_growth_runeforge) or spellcooldown(feral_spirit) > 15 spell(fae_transfusion)

  unless buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or 600 >= 40 and spell(sundering) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt)
   {
    #fleshcraft,if=soulbind.pustule_eruption
    if soulbind(pustule_eruption_soulbind) spell(fleshcraft)
    #earth_elemental
    spell(earth_elemental)
   }
  }
 }
}

AddFunction enhancementsinglecdpostconditions
{
 spell(windstrike) or { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(stormstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(ice_strike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(sundering) or not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(vesper_totem) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(earthen_spike) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and 600 >= 90 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) == 10 and spell(lightning_bolt) or spell(stormstrike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or spell(lava_lash) or spell(crash_lightning) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or 600 >= 40 and spell(sundering) or debuffcountonany(flame_shock) and spell(fire_nova) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

### actions.precombat

AddFunction enhancementprecombatmainactions
{
 #flask
 #food
 #augmentation
 #windfury_weapon
 spell(windfury_weapon)
 #flametongue_weapon
 if buffexpires(flametongue_weapon) spell(flametongue_weapon)
 #lightning_shield
 if buffexpires(lightning_shield) spell(lightning_shield)
 #windfury_totem,if=!runeforge.doom_winds.equipped
 if not equippedruneforge(doom_winds_runeforge) spell(windfury_totem)
}

AddFunction enhancementprecombatmainpostconditions
{
}

AddFunction enhancementprecombatshortcdactions
{
 unless spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield)
 {
  #stormkeeper,if=talent.stormkeeper.enabled
  if hastalent(stormkeeper_talent_enhancement) spell(stormkeeper_enhancement)
 }
}

AddFunction enhancementprecombatshortcdpostconditions
{
 spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
}

AddFunction enhancementprecombatcdactions
{
 unless spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or hastalent(stormkeeper_talent_enhancement) and spell(stormkeeper_enhancement) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
 {
  #fleshcraft,if=soulbind.pustule_eruption|soulbind.volatile_solvent
  if soulbind(pustule_eruption_soulbind) or soulbind(volatile_solvent_soulbind) spell(fleshcraft)
  #potion
  if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_agility_item usable=1)
 }
}

AddFunction enhancementprecombatcdpostconditions
{
 spell(windfury_weapon) or buffexpires(flametongue_weapon) and spell(flametongue_weapon) or buffexpires(lightning_shield) and spell(lightning_shield) or hastalent(stormkeeper_talent_enhancement) and spell(stormkeeper_enhancement) or not equippedruneforge(doom_winds_runeforge) and spell(windfury_totem)
}

### actions.aoe

AddFunction enhancementaoemainactions
{
 #windstrike,if=buff.crash_lightning.up
 if buffpresent(crash_lightning) spell(windstrike)
 #crash_lightning,if=runeforge.doom_winds.equipped&buff.doom_winds.up
 if equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) spell(crash_lightning)
 #frost_shock,if=buff.hailstorm.up
 if buffpresent(hailstorm_buff) spell(frost_shock)
 #flame_shock,target_if=refreshable,cycle_targets=1,if=talent.fire_nova.enabled|talent.lashing_flames.enabled|covenant.necrolord|runeforge.primal_lava_actuators.equipped
 if target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } spell(flame_shock)
 #fire_nova,if=active_dot.flame_shock>=3
 if debuffcountonany(flame_shock) >= 3 spell(fire_nova)
 #lightning_bolt,if=buff.primordial_wave.up&buff.maelstrom_weapon.stack>=5
 if buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 spell(lightning_bolt)
 #chain_lightning,if=buff.stormkeeper.up
 if buffpresent(stormkeeper_enhancement) spell(chain_lightning)
 #crash_lightning,if=talent.crashing_storm.enabled|buff.crash_lightning.down
 if hastalent(crashing_storm_talent) or buffexpires(crash_lightning) spell(crash_lightning)
 #lava_lash,target_if=min:debuff.lashing_flames.remains,cycle_targets=1,if=talent.lashing_flames.enabled
 if hastalent(lashing_flames_talent) spell(lava_lash)
 #lava_lash,if=buff.crash_lightning.up&(buff.hot_hand.up|(runeforge.primal_lava_actuators.equipped&buff.primal_lava_actuators.stack>6))
 if buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } spell(lava_lash)
 #stormstrike,if=buff.crash_lightning.up
 if buffpresent(crash_lightning) spell(stormstrike)
 #crash_lightning
 spell(crash_lightning)
 #elemental_blast,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(elemental_blast)
 #chain_lightning,if=buff.maelstrom_weapon.stack=10
 if buffstacks(maelstrom_weapon_buff) == 10 spell(chain_lightning)
 #windstrike
 spell(windstrike)
 #stormstrike
 spell(stormstrike)
 #lava_lash
 spell(lava_lash)
 #flame_shock,target_if=refreshable,cycle_targets=1
 if target.refreshable(flame_shock) spell(flame_shock)
 #frost_shock
 spell(frost_shock)
 #ice_strike
 spell(ice_strike)
 #chain_lightning,if=buff.maelstrom_weapon.stack>=5
 if buffstacks(maelstrom_weapon_buff) >= 5 spell(chain_lightning)
 #fire_nova,if=active_dot.flame_shock>1
 if debuffcountonany(flame_shock) > 1 spell(fire_nova)
 #earthen_spike
 spell(earthen_spike)
 #windfury_totem,if=buff.windfury_totem.remains<30
 if buffremaining(windfury_totem) < 30 spell(windfury_totem)
}

AddFunction enhancementaoemainpostconditions
{
}

AddFunction enhancementaoeshortcdactions
{
 unless buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock)
 {
  #sundering
  spell(sundering)

  unless target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock)
  {
   #primordial_wave,target_if=min:dot.flame_shock.remains,cycle_targets=1,if=!buff.primordial_wave.up
   if not buffpresent(primordial_wave_buff) spell(primordial_wave)

   unless debuffcountonany(flame_shock) >= 3 and spell(fire_nova)
   {
    #vesper_totem
    spell(vesper_totem)

    unless buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning)
    {
     #chain_harvest,if=buff.maelstrom_weapon.stack>=5
     if buffstacks(maelstrom_weapon_buff) >= 5 spell(chain_harvest)

     unless buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast)
     {
      #stormkeeper,if=buff.maelstrom_weapon.stack>=5
      if buffstacks(maelstrom_weapon_buff) >= 5 spell(stormkeeper_enhancement)
     }
    }
   }
  }
 }
}

AddFunction enhancementaoeshortcdpostconditions
{
 buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

AddFunction enhancementaoecdactions
{
 unless buffpresent(crash_lightning) and spell(windstrike)
 {
  #fae_transfusion,if=soulbind.grove_invigoration|soulbind.field_of_blossoms
  if soulbind(grove_invigoration_soulbind) or soulbind(field_of_blossoms_soulbind) spell(fae_transfusion)

  unless equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(sundering) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or spell(vesper_totem) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash)
  {
   #fleshcraft,interrupt=1,if=soulbind.volatile_solvent
   if soulbind(volatile_solvent_soulbind) spell(fleshcraft)

   unless target.refreshable(flame_shock) and spell(flame_shock)
   {
    #fae_transfusion
    spell(fae_transfusion)

    unless spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike)
    {
     #earth_elemental
     spell(earth_elemental)
    }
   }
  }
 }
}

AddFunction enhancementaoecdpostconditions
{
 buffpresent(crash_lightning) and spell(windstrike) or equippedruneforge(doom_winds_runeforge) and buffpresent(doom_winds_buff) and spell(crash_lightning) or buffpresent(hailstorm_buff) and spell(frost_shock) or spell(sundering) or target.refreshable(flame_shock) and { hastalent(fire_nova_talent) or hastalent(lashing_flames_talent) or iscovenant("necrolord") or equippedruneforge(primal_lava_actuators_runeforge) } and spell(flame_shock) or not buffpresent(primordial_wave_buff) and spell(primordial_wave) or debuffcountonany(flame_shock) >= 3 and spell(fire_nova) or spell(vesper_totem) or buffpresent(primordial_wave_buff) and buffstacks(maelstrom_weapon_buff) >= 5 and spell(lightning_bolt) or buffpresent(stormkeeper_enhancement) and spell(chain_lightning) or { hastalent(crashing_storm_talent) or buffexpires(crash_lightning) } and spell(crash_lightning) or hastalent(lashing_flames_talent) and spell(lava_lash) or buffpresent(crash_lightning) and { buffpresent(hot_hand_buff) or equippedruneforge(primal_lava_actuators_runeforge) and buffstacks(primal_lava_actuators_buff) > 6 } and spell(lava_lash) or buffpresent(crash_lightning) and spell(stormstrike) or spell(crash_lightning) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_harvest) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(elemental_blast) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(stormkeeper_enhancement) or buffstacks(maelstrom_weapon_buff) == 10 and spell(chain_lightning) or spell(windstrike) or spell(stormstrike) or spell(lava_lash) or target.refreshable(flame_shock) and spell(flame_shock) or spell(frost_shock) or spell(ice_strike) or buffstacks(maelstrom_weapon_buff) >= 5 and spell(chain_lightning) or debuffcountonany(flame_shock) > 1 and spell(fire_nova) or spell(earthen_spike) or buffremaining(windfury_totem) < 30 and spell(windfury_totem)
}

### actions.default

AddFunction enhancement_defaultmainactions
{
 #heart_essence
 if hasequippeditem(158075) and level() < 50 spell(296208)
 #windfury_totem,if=runeforge.doom_winds.equipped&buff.doom_winds_debuff.down&(raid_event.adds.in>=60|active_enemies>1)
 if equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } spell(windfury_totem)
 #call_action_list,name=single,if=active_enemies=1
 if enemies() == 1 enhancementsinglemainactions()

 unless enemies() == 1 and enhancementsinglemainpostconditions()
 {
  #call_action_list,name=aoe,if=active_enemies>1
  if enemies() > 1 enhancementaoemainactions()
 }
}

AddFunction enhancement_defaultmainpostconditions
{
 enemies() == 1 and enhancementsinglemainpostconditions() or enemies() > 1 and enhancementaoemainpostconditions()
}

AddFunction enhancement_defaultshortcdactions
{
 #auto_attack
 enhancementgetinmeleerange()

 unless hasequippeditem(158075) and level() < 50 and spell(296208)
 {
  #bag_of_tricks,if=!talent.ascendance.enabled|!buff.ascendance.up
  if not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) spell(bag_of_tricks)

  unless equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem)
  {
   #call_action_list,name=single,if=active_enemies=1
   if enemies() == 1 enhancementsingleshortcdactions()

   unless enemies() == 1 and enhancementsingleshortcdpostconditions()
   {
    #call_action_list,name=aoe,if=active_enemies>1
    if enemies() > 1 enhancementaoeshortcdactions()
   }
  }
 }
}

AddFunction enhancement_defaultshortcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208) or equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem) or enemies() == 1 and enhancementsingleshortcdpostconditions() or enemies() > 1 and enhancementaoeshortcdpostconditions()
}

AddFunction enhancement_defaultcdactions
{
 #bloodlust
 enhancementbloodlust()
 #potion,if=expected_combat_length-time<60
 if expectedcombatlength() - timeincombat() < 60 and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_agility_item usable=1)
 #wind_shear
 enhancementinterruptactions()

 unless hasequippeditem(158075) and level() < 50 and spell(296208)
 {
  #use_items
  enhancementuseitemactions()
  #blood_fury,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(blood_fury_ap_int)
  #berserking,if=!talent.ascendance.enabled|buff.ascendance.up
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) spell(berserking)
  #fireblood,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(fireblood)
  #ancestral_call,if=!talent.ascendance.enabled|buff.ascendance.up|cooldown.ascendance.remains>50
  if not hastalent(ascendance_talent_enhancement) or buffpresent(ascendance_enhancement) or spellcooldown(ascendance_enhancement) > 50 spell(ancestral_call)

  unless { not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) } and spell(bag_of_tricks)
  {
   #feral_spirit
   spell(feral_spirit)
   #fae_transfusion,if=(talent.ascendance.enabled|runeforge.doom_winds.equipped)&(soulbind.grove_invigoration|soulbind.field_of_blossoms|active_enemies=1)
   if { hastalent(ascendance_talent_enhancement) or equippedruneforge(doom_winds_runeforge) } and { soulbind(grove_invigoration_soulbind) or soulbind(field_of_blossoms_soulbind) or enemies() == 1 } spell(fae_transfusion)
   #ascendance,if=raid_event.adds.in>=90|active_enemies>1
   if { 600 >= 90 or enemies() > 1 } and buffexpires(ascendance_enhancement) spell(ascendance_enhancement)

   unless equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem)
   {
    #call_action_list,name=single,if=active_enemies=1
    if enemies() == 1 enhancementsinglecdactions()

    unless enemies() == 1 and enhancementsinglecdpostconditions()
    {
     #call_action_list,name=aoe,if=active_enemies>1
     if enemies() > 1 enhancementaoecdactions()
    }
   }
  }
 }
}

AddFunction enhancement_defaultcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208) or { not hastalent(ascendance_talent_enhancement) or not buffpresent(ascendance_enhancement) } and spell(bag_of_tricks) or equippedruneforge(doom_winds_runeforge) and buffexpires(doom_winds) and { 600 >= 60 or enemies() > 1 } and spell(windfury_totem) or enemies() == 1 and enhancementsinglecdpostconditions() or enemies() > 1 and enhancementaoecdpostconditions()
}

### Enhancement icons.

AddCheckBox(opt_shaman_enhancement_aoe l(aoe) default enabled=(specialization(enhancement)))

AddIcon enabled=(not checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) enemies=1 help=shortcd
{
 if not incombat() enhancementprecombatshortcdactions()
 enhancement_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=shortcd
{
 if not incombat() enhancementprecombatshortcdactions()
 enhancement_defaultshortcdactions()
}

AddIcon enabled=(specialization(enhancement)) enemies=1 help=main
{
 if not incombat() enhancementprecombatmainactions()
 enhancement_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=aoe
{
 if not incombat() enhancementprecombatmainactions()
 enhancement_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) enemies=1 help=cd
{
 if not incombat() enhancementprecombatcdactions()
 enhancement_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_enhancement_aoe) and specialization(enhancement)) help=cd
{
 if not incombat() enhancementprecombatcdactions()
 enhancement_defaultcdactions()
}

### Required symbols
# ancestral_call
# ascendance_enhancement
# ascendance_talent_enhancement
# bag_of_tricks
# berserking
# blood_fury_ap_int
# bloodlust
# capacitor_totem
# chain_harvest
# chain_lightning
# crash_lightning
# crashing_storm_talent
# doom_winds
# doom_winds_buff
# doom_winds_runeforge
# earth_elemental
# earthen_spike
# elemental_blast
# fae_transfusion
# feral_lunge
# feral_spirit
# field_of_blossoms_soulbind
# fire_nova
# fire_nova_talent
# fireblood
# flame_shock
# flametongue_weapon
# fleshcraft
# frost_shock
# grove_invigoration_soulbind
# hailstorm_buff
# heroism
# hex
# hot_hand_buff
# ice_strike
# lashing_flames_talent
# lava_lash
# lightning_bolt
# lightning_shield
# maelstrom_weapon_buff
# potion_of_spectral_agility_item
# primal_lava_actuators_buff
# primal_lava_actuators_runeforge
# primordial_wave
# primordial_wave_buff
# pustule_eruption_soulbind
# quaking_palm
# seeds_of_rampant_growth_runeforge
# stormkeeper_enhancement
# stormkeeper_talent_enhancement
# stormstrike
# sundering
# vesper_totem
# volatile_solvent_soulbind
# war_stomp
# wind_shear
# windfury_totem
# windfury_weapon
# windstrike
]]
        scripts:registerScript("SHAMAN", "enhancement", name, desc, code, "script")
    end
    do
        local name = "sc_t27_shaman_restoration"
        local desc = "[9.1] Simulationcraft: T27_Shaman_Restoration"
        local code = [[
# Based on SimulationCraft profile "T27_Shaman_Restoration".
#	class=shaman
#	spec=restoration
#	talents=0100200

Include(ovale_common)
Include(ovale_shaman_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(restoration)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(restoration)))

AddFunction restorationinterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(wind_shear) and target.isinterruptible() spell(wind_shear)
  if not target.classification(worldboss) and target.remainingcasttime() > 2 spell(capacitor_totem)
  if target.inrange(quaking_palm) and not target.classification(worldboss) spell(quaking_palm)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
  if target.inrange(hex) and not target.classification(worldboss) and target.remainingcasttime() > casttime(hex) + gcdremaining() and target.creaturetype(humanoid beast) spell(hex)
 }
}

AddFunction restorationuseitemactions
{
 item("trinket0Slot" text=13 usable=1)
 item("trinket1Slot" text=14 usable=1)
}

### actions.precombat

AddFunction restorationprecombatmainactions
{
}

AddFunction restorationprecombatmainpostconditions
{
}

AddFunction restorationprecombatshortcdactions
{
}

AddFunction restorationprecombatshortcdpostconditions
{
}

AddFunction restorationprecombatcdactions
{
 #flask
 #food
 #augmentation
 #earth_elemental
 spell(earth_elemental)
 #snapshot_stats
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
}

AddFunction restorationprecombatcdpostconditions
{
}

### actions.default

AddFunction restoration_defaultmainactions
{
 #flame_shock,if=!ticking
 if not target.debuffpresent(flame_shock) spell(flame_shock)
 #lava_burst,if=dot.flame_shock.remains>cast_time&cooldown_react
 if target.debuffremaining(flame_shock) > casttime(lava_burst) and not spellcooldown(lava_burst) > 0 spell(lava_burst)
 #lightning_bolt,if=spell_targets.chain_lightning<3
 if enemies(tagged=1) < 3 spell(lightning_bolt)
 #chain_lightning,if=spell_targets.chain_lightning>2
 if enemies(tagged=1) > 2 spell(chain_lightning)
 #flame_shock,moving=1
 if speed() > 0 spell(flame_shock)
 #frost_shock,moving=1
 if speed() > 0 spell(frost_shock)
}

AddFunction restoration_defaultmainpostconditions
{
}

AddFunction restoration_defaultshortcdactions
{
 unless not target.debuffpresent(flame_shock) and spell(flame_shock)
 {
  #bag_of_tricks
  spell(bag_of_tricks)
  #chain_harvest,if=covenant.venthyr
  if iscovenant("venthyr") spell(chain_harvest)
  #vesper_totem,if=covenant.kyrian
  if iscovenant("kyrian") spell(vesper_totem)

  unless target.debuffremaining(flame_shock) > casttime(lava_burst) and not spellcooldown(lava_burst) > 0 and spell(lava_burst)
  {
   #primordial_wave,if=covenant.necrolord
   if iscovenant("necrolord") spell(primordial_wave)
  }
 }
}

AddFunction restoration_defaultshortcdpostconditions
{
 not target.debuffpresent(flame_shock) and spell(flame_shock) or target.debuffremaining(flame_shock) > casttime(lava_burst) and not spellcooldown(lava_burst) > 0 and spell(lava_burst) or enemies(tagged=1) < 3 and spell(lightning_bolt) or enemies(tagged=1) > 2 and spell(chain_lightning) or speed() > 0 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

AddFunction restoration_defaultcdactions
{
 #spiritwalkers_grace,moving=1,if=movement.distance>6
 if speed() > 0 and target.distance() > 6 spell(spiritwalkers_grace)
 #wind_shear
 restorationinterruptactions()
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_intellect_item usable=1)
 #use_items
 restorationuseitemactions()

 unless not target.debuffpresent(flame_shock) and spell(flame_shock)
 {
  #earth_elemental
  spell(earth_elemental)
  #blood_fury
  spell(blood_fury_ap_int)
  #berserking
  spell(berserking)
  #fireblood
  spell(fireblood)
  #ancestral_call
  spell(ancestral_call)

  unless spell(bag_of_tricks) or iscovenant("venthyr") and spell(chain_harvest) or iscovenant("kyrian") and spell(vesper_totem) or target.debuffremaining(flame_shock) > casttime(lava_burst) and not spellcooldown(lava_burst) > 0 and spell(lava_burst)
  {
   #fae_transfusion,if=covenant.night_fae
   if iscovenant("night_fae") spell(fae_transfusion)
  }
 }
}

AddFunction restoration_defaultcdpostconditions
{
 not target.debuffpresent(flame_shock) and spell(flame_shock) or spell(bag_of_tricks) or iscovenant("venthyr") and spell(chain_harvest) or iscovenant("kyrian") and spell(vesper_totem) or target.debuffremaining(flame_shock) > casttime(lava_burst) and not spellcooldown(lava_burst) > 0 and spell(lava_burst) or iscovenant("necrolord") and spell(primordial_wave) or enemies(tagged=1) < 3 and spell(lightning_bolt) or enemies(tagged=1) > 2 and spell(chain_lightning) or speed() > 0 and spell(flame_shock) or speed() > 0 and spell(frost_shock)
}

### Restoration icons.

AddCheckBox(opt_shaman_restoration_aoe l(aoe) default enabled=(specialization(restoration)))

AddIcon enabled=(not checkboxon(opt_shaman_restoration_aoe) and specialization(restoration)) enemies=1 help=shortcd
{
 if not incombat() restorationprecombatshortcdactions()
 restoration_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_restoration_aoe) and specialization(restoration)) help=shortcd
{
 if not incombat() restorationprecombatshortcdactions()
 restoration_defaultshortcdactions()
}

AddIcon enabled=(specialization(restoration)) enemies=1 help=main
{
 if not incombat() restorationprecombatmainactions()
 restoration_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_shaman_restoration_aoe) and specialization(restoration)) help=aoe
{
 if not incombat() restorationprecombatmainactions()
 restoration_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_shaman_restoration_aoe) and specialization(restoration)) enemies=1 help=cd
{
 if not incombat() restorationprecombatcdactions()
 restoration_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_shaman_restoration_aoe) and specialization(restoration)) help=cd
{
 if not incombat() restorationprecombatcdactions()
 restoration_defaultcdactions()
}

### Required symbols
# ancestral_call
# bag_of_tricks
# berserking
# blood_fury_ap_int
# capacitor_totem
# chain_harvest
# chain_lightning
# earth_elemental
# fae_transfusion
# fireblood
# flame_shock
# frost_shock
# hex
# lava_burst
# lightning_bolt
# potion_of_spectral_intellect_item
# primordial_wave
# quaking_palm
# spiritwalkers_grace
# vesper_totem
# war_stomp
# wind_shear
]]
        scripts:registerScript("SHAMAN", "restoration", name, desc, code, "script")
    end
end
